unit graph5;
interface
uses crt,graph,maus,grini;
CONST maxstring  = 30;
      maxpunkte  = 23;
      maxseiten  = 15;

  TYPE TXT70=STRING[70];
       CHARSET=SET OF CHAR;
    menubalkentyp = RECORD
            xa,ya,xe,ye : Word;
            size        : Word;
            grund       : Pointer;
    END;
    menupunktetxt = String[MAXSTRING];
    seitenptr     = ^menuseitentyp;
    punkteptr     = ^menupunktetxt;
    menuseitentyp = RECORD
            punktzahl       : Word;   (* aktuelle Menupunktzahl *)
            titel           : String[maxstring];
            txa,tya,txe,tye : Word;
            punkt           : Array[1..maxpunkte] Of punkteptr;
            pxa,pya,pxe,pye : Array[1..maxpunkte] Of Word;
            xa,ya,xe,ye     : Word;         (* Anfang/Ende      *)
            size            : Word;        (* Pixel-Array-Gre *)
            grund           : Pointer;  (* Menu-Abbild in Pixel *)
     END;
     menutyp = RECORD
            balken        : menubalkentyp;
            seitenzahl    : Word;        (* aktuelle Seitenzahl *)
            seite         : Array[1..maxseiten] Of seitenptr;
            vf,hf,ivf,ihf : Word;                     (* Farben *)
            tief          : integer;
            font,richt,
            charsize      : Word;                 (* Text-Style *)
     END;

const zahl1:charset=['0'..'9'];
      zahl2:charset=['0'..'9',',','.'];
      zeichen:charset=['A'..'Z','a'..'z','0'..'9',',','.','-','!','?','',
                       '','','','','','',' '];
      BUCHSTABEN:charset=['A'..'Z','a'..'z','','','','','','',''];
      fontdy  : Array[1..10] Of Byte = (5,5,7,8,10,11,15,19,22,29);
      sfontdy : Array[1..10] Of Byte = (2,2,2,3,3,4,5,6,7,9);
      blinkstop=50;space='                ';
      willmaus  : Boolean = False;
      STAERKE:ARRAY[1..10]OF STRING[25]=
             ('1 - Anfnger','2 - Gebter','3 - Erfahrener',
              '4 - Fortgeschrittener','5 - Knner','6 - Meister',
              '7 - Gromeister','8 - Weltmeister','9 - Genie','10 - Superhirn');
      FELDGR:ARRAY[1..7]OF STRING[14]=
      (' 7 X  7 - Feld',' 9 X  9 - Feld','11 X 11 - Feld','13 X 13 - Feld',
       '15 X 15 - Feld','17 X 17 - Feld','19 X 19 - Feld');

VAR menu:menutyp;
    dtext:array[1..20] of string[35];
    vga:boolean;

procedure install_graph;
procedure box(x1,y1,x2,y2,farbe,art:Word;fuellen:boolean);
{             art = 1  hervortretende Box
                    2  Box nach innen
                    4  normale Box        }
function auswahl(xm,y1:word;text1,text2,text3,antw1,antw2:string;Hfarbe,Sfarbe,wo:Byte):char;
procedure weiter(x1,y1:word;Hfarbe,Sfarbe:byte);
PROCEDURE GText(x,y,tf,hf:Integer;txt:TXT70);
FUNCTION FragText(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte;buch:charset):TXT70;
FUNCTION FragInt(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte):Integer;
FUNCTION FragInt2(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte):LONGINT;
FUNCTION FragText2(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte;buch:charset):TXT70;
PROCEDURE MELDUNG(xm,y1:word;text1,text2,text3:TXT70;Hfarbe,Sfarbe:Byte);
function eingabe(x1,y1,max:word;art:charset):string;
procedure open_window(x1,y1,x2,y2:word;HF,SF,KF:BYTE;text:string);
PROCEDURE CLEAR_WINDOW(X1,Y1,X2,Y2:WORD;HF:BYTE);
FUNCTION FragReal(xm,y1:Integer;text1,text2,text3:txt70;HF,SF:BYTE;max:Word;VAR ok:Boolean):Real;
procedure dialog(xm,y1:word;HF,SF:BYTE;text:string);
procedure wahl(xm,y1:word;HF,SF:BYTE;text:string;var k3:BYTE);
procedure feldnr(xm,y1:word;HF,SF:BYTE;text:string;var k3:BYTE);
PROCEDURE MenuInit(x1k,y1k,x2k,HINTERGRUNDFARBE,TEXTFARBE:integer;VAR menutxt;s,p,l:Word);
PROCEDURE ChangeMenu(snr,pnr:byte;text1:string);
PROCEDURE ShowMenu;
PROCEDURE MenuFree;
PROCEDURE MenuMark(snr,pnr:Integer);
PROCEDURE MenuWahl(VAR snr,pnr:Integer);
procedure piep;

implementation

procedure EgaVgaDriverProc;EXTERNAL;
  {$L EGAVGA.OBJ}

procedure install_graph;
var dummy,driver,mode,k:integer;
begin
 dummy:=registerbgidriver(@EgaVgaDriverProc);
 detectgraph(driver,mode);graphein(driver,mode,'');
 mausgrenze(0,0,maxx,maxy);setzmaus(0,0);mauson(false);
 mausda:=true;willmaus:=true;
 if maxy>400 then vga:=true else vga:=false;
 for k:=1 to 20 do dtext[k]:=' ';
end;

{----------------------------------------------------------------------}

PROCEDURE BOX(X1,Y1,X2,Y2,FARBE,ART:WORD;FUELLEN:BOOLEAN);
  CONST HELL  : ARRAY[0..15]OF BYTE=(7,9,10,11,12,13,14,15,15,15,15,15,15,15,15,15);
        DUNKEL: ARRAY[0..15]OF BYTE=(0,8,8,8,8,8,8,8,8,1,2,3,4,5,6,7);
  VAR I,COL,DICKE:INTEGER;
  BEGIN
   COL:=GETCOLOR;DICKE:=-ART+4;
   IF FUELLEN THEN BEGIN SETFILLSTYLE(1,FARBE);BAR(X1,Y1,X2,Y2) END;
   IF ART=1 THEN SETCOLOR(HELL[FARBE]) ELSE SETCOLOR(DUNKEL[FARBE]);
   FOR I:=0 TO DICKE-1 DO
    BEGIN
     LINE(X1+I,Y2-I,X1+I,Y1+I);
     LINE(X1+I,Y1+I,X2-I,Y1+I);
    END;
   IF ART=1 THEN SETCOLOR(DUNKEL[FARBE]) ELSE SETCOLOR(HELL[FARBE]);
   FOR I:=0 TO DICKE-1 DO
    BEGIN
     LINE(X1+I+1,Y2-I,X2-I,Y2-I);
     LINE(X2-I,Y2-I,X2-I,Y1+I+1);
    END;
   SETCOLOR(COL);
  END;

{----------------------------------------------------------------------}

procedure strich(x1,y1,laenge,richtung:word);
var col:word;
begin
 col:=getcolor;setcolor(8);
 if richtung=0 then begin
  line(x1,y1,x1+laenge,y1);setcolor(15);
  line(x1,y1+1,x1+laenge,y1+1);
 end else begin
  line(x1,y1,x1,y1+laenge);setcolor(15);
  line(x1+1,y1,x1+1,y1+laenge);
 end;
 setcolor(col);
end;

{----------------------------------------------------------------------}

PROCEDURE XorRec(x1,y1,x2,y2:Integer);
VAR dy,dx,c : Integer;
BEGIN
  IF x1=x2 THEN dx:=0 ELSE dx:=Ord(x1<x2)*2-1;
  IF y1=y2 THEN dy:=0 ELSE dy:=Ord(y1<y2)*2-1;
  c:=GetColor; SetColor(GetMaxColor); SetWriteMode(1);
  Line(x1,y1,x2-dx,y1); Line(x2,y1,x2,y2-dy);
  IF y1<>y2 THEN Line(x2,y2,x1+dx,y2);
  IF x1<>x2 THEN Line(x1,y2,x1,y1+dy);
  IF (dx=0) And (dy=0) THEN Line(x1,y1,x2,y2);
  SetColor(c); SetWriteMode(0);
END;

{----------------------------------------------------------------------}

PROCEDURE CursorBlinken(x1,y1,x2,y2,stop:Integer);
                                           (* stop: Verzgerung *)
VAR c1,c2,n : Word;
BEGIN
  n:=0; willmaus:=willmaus And mausda;
  REPEAT
    IF willmaus THEN WHILE MausKey<>0 DO; MausOn(False);
    XorRec(x1,y1,x2,y2); n:=(n+1) Mod 2;
    IF willmaus THEN MausOn(True);
    FOR c1:=0 TO stop DO FOR c2:=0 TO stop DO
      IF KeyPressed Or (willmaus And (MausKey<>0)) THEN BEGIN
        IF Odd(n) THEN BEGIN
          MausOn(False); XorRec(x1,y1,x2,y2);
          IF willmaus THEN MausOn(True);
        END;
        Exit;
      END;
  UNTIL false;                                (* Endlosschleife *)
END;

{----------------------------------------------------------------------}

FUNCTION GRead(xa,ya,xe,ye,x,y,tf,hf,st:Integer;
                                          zeichen:charset):txt70;
(* Liest String aus Grafik, Abbruch: <esc>, Abschlu: <enter>   *)
              (* Lschen mit <Backspace>                        *)
              (* xa,ya,xe,ye: Eckpunkte Requester               *)
              (* x/y: Pixelanfang der Maske                     *)
              (* txt:  zu erstellender Text-String              *)
              (* st: Stellenzahl des Strings (der Maske)        *)
              (* tf/hf: Zeichen-/Hintergrundfarbe               *)
              (* zeichen: erlaubte String-Zeichen               *)
VAR c                 : Char;
    txt               : txt70;
    cpos,len,wx,wy,x1 : Word;
    mkey              : Integer;
BEGIN
  willmaus:=willmaus And mausda;
  zeichen:=zeichen+[#8,#13,#27,#0];
  wx:=TextWidth('0'); wy:=TextHeight('0');
  txt[0]:=Chr(st); FillChar(txt[1],st,' ');
  MausOn(False); GText(x,y,hf,hf,txt);
  IF willmaus THEN MausOn(True);
  txt:=''; c:=#0; len:=1;
  REPEAT
    IF len<st+1 THEN cpos:=len ELSE cpos:=len-1;
    x1:=x+(cpos-1)*wx;
    MausOn(False); GText(x1,y,tf,hf,txt[cpos]);
    IF willmaus THEN MausOn(True);
    REPEAT c:=#0;
      CursorBlinken(x1-1,y-1,x1+wx-1,y+wy-1,blinkstop);
      IF willmaus THEN mkey:=MausKey ELSE mkey:=0;
      IF mkey=0 THEN c:=ReadKey;
    UNTIL (c In zeichen) Or (willmaus And (MausWahl(xa,ya,xe,ye,1)
                                        Or MausWahl(xa,ya,xe,ye,2)));
    IF (c<>#27) And (c<>#13) And (mkey=0) THEN BEGIN
      IF c<>#0 THEN
        IF c<>#8 THEN BEGIN
          MausOn(False); GText(x1,y,tf,hf,c); txt[len]:=c;
          IF willmaus THEN MausOn(True);
          Inc(len);
          IF len>(st+1) THEN BEGIN len:=st+1; END;
        END ELSE BEGIN                        (* BACKSPACE *)
          Dec(len); IF len<1 THEN len:=1; txt[len]:=' ';
        END
      ELSE BEGIN c:=ReadKey;
        IF c=#83 THEN BEGIN                         (* DEL *)
          txt[0]:=Chr(st); FillChar(txt[1],st,' ');
          MausOn(False); GText(x,y,hf,hf,txt);
          IF willmaus THEN MausOn(True);
          txt:=''; len:=1;
        END;
      END;
    END;
  UNTIL (c=#27) Or (c=#13) Or ((mkey>0) And willmaus);
  txt[0]:=Chr(len-1);
  IF (c=#27) Or (mkey>1) THEN GRead:=#27 ELSE GRead:=txt;
END;

{----------------------------------------------------------------------}

function eingabe(x1,y1,max:word;art:charset):string;
begin
 eingabe:=gread(x1,y1,x1+8*max,y1+8,x1,y1,0,7,max,art);
end;

{----------------------------------------------------------------------}

procedure open_window(x1,y1,x2,y2:word;HF,SF,KF:BYTE;text:string);
var col:word;
begin
 mauson(false);col:=getcolor;
 box(x1,y1,x2,y2,HF,1,true);box(x1+5,y1+5,x2-5,y2-5,HF,2,false);
 strich(x1+1,y2-20,3,0);strich(x2-4,y2-20,3,0);
 strich(x1+30,y2-4,3,1);strich(x2-30,y2-4,3,1);
 strich(x1+1,y1+20,3,0);strich(x2-4,y1+20,3,0);
 strich(x1+30,y1+1,3,1);strich(x2-30,y1+1,3,1);
 setfillstyle(1,8);bar(x1+6,y1+6,x2-6,y1+20);
 box(x1+6,y1+6,x1+30,y1+20,KF,1,true);
 SETLINESTYLE(SOLIDLN,0,NORMWIDTH);
 setcolor(WHITE);line(x1+11,y1+14,x1+24,y1+14);line(x1+11,y1+13,x1+24,y1+13);
 setcolor(BLACK);line(x1+12,y1+14,x1+25,y1+14);line(x1+12,y1+15,x1+25,y1+15);
 box(x1+31,y1+6,x2-6,y1+20,HF,4,false);
 settextjustify(centertext,toptext);setcolor(SF);
 outtextxy(x1+15+((x2-x1) div 2),y1+10,text);
 settextjustify(lefttext,toptext);
 mauson(true);setcolor(col);
end;

{----------------------------------------------------------------------}

 PROCEDURE CLEAR_WINDOW(X1,Y1,X2,Y2:WORD;HF:BYTE);
  BEGIN
   MAUSON(FALSE);SETFILLSTYLE(SOLIDFILL,HF);
   BAR(X1+10,Y1+21,X2-10,Y2-10);
   MAUSON(TRUE)
  END;

{----------------------------------------------------------------------}

PROCEDURE MELDUNG(xm,y1:word;text1,text2,text3:TXT70;Hfarbe,Sfarbe:Byte);
var hoehe,col,k,k2:word;
    pufa:pointer;
    Ok:Boolean;
begin
 col:=getcolor;k:=14;
 if length(text1)>k then k:=length(text1);
 if length(text2)>k then k:=length(text2);
 if length(text3)>k then k:=length(text3);
 k2:=k;mauson(false);hoehe:=38;
 if length(text2)>0 then inc(hoehe,12);
 if length(text3)>0 then inc(hoehe,12);
 k:=imagesize(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1);
 getmem(pufa,k);getimage(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,pufa^);
 box(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,Hfarbe,1,true);
 box(xm-(4*k2)-15,y1+2,xm+(4*k2)+15,y1+hoehe-2,Hfarbe,2,false);
 setcolor(Sfarbe);outtextxy(xm-length(text1)*4,y1+6,text1);
 if text2<>'' then outtextxy(xm-length(text2)*4,y1+18,text2);
 if text3<>'' then outtextxy(xm-length(text3)*4,y1+30,text3);
 box(xm-30,y1+hoehe-22,xm+30,y1+hoehe-5,Hfarbe,1,false);
 outtextxy(xm-20,y1+hoehe-17,'weiter');
 mauson(true);WHILE MausKey<>0 DO;
 setzmaus(xm,y1+hoehe-15);
 repeat
  Ok:=mauswahl(xm-30,y1+hoehe-22,xm+30,y1+hoehe-5,1);
 until Ok or (mauskey=2);
 mauson(false);
 box(xm-30,y1+hoehe-22,xm+30,y1+hoehe-5,Hfarbe,2,false);
 setcolor(col);delay(1000);
 putimage(xm-(4*k2)-20,y1-1,pufa^,0);freemem(pufa,k);mauson(true);
end;

{----------------------------------------------------------------------}

procedure dialog(xm,y1:word;HF,SF:BYTE;text:STRING);
var k3,k2,col,ende,j:byte;
    k:word;
    pufa:pointer;
begin
 ende:=21;
 for j:=20 downto 1 do if dtext[j]='' then dec(ende) else j:=1;
 if ende>4 then dec(ende,4) else ende:=1;
 k:=imagesize(xm-170,y1,xm+170,y1+105);mauson(false);col:=getcolor;
 getmem(pufa,k);getimage(xm-170,y1,xm+170,y1+105,pufa^);
 open_window(xm-170,y1,xm+170,y1+105,HF,SF,HF,text);mauson(false);
 setcolor(SF);rectangle(xm-161,y1+24,xm+141,y1+71);
 box(xm+147,y1+24,xm+160,y1+38,HF,1,false);outtextxy(xm+150,y1+28,chr(24));
 box(xm+147,y1+57,xm+160,y1+71,HF,1,false);outtextxy(xm+150,y1+61,chr(25));
 box(xm-48,y1+75,xm+48,y1+95,HF,1,false);outtextxy(xm-40,y1+82,'alles klar');
 mauson(true);setzmaus(xm,y1+85);k2:=0;k3:=1;setfillstyle(1,15);
 repeat
  if k2=0 then
   begin
    bar(xm-160,y1+25,xm+140,y1+70);k2:=1;
    outtextxy(xm-155,y1+30,dtext[k3]);
    outtextxy(xm-155,y1+40,dtext[k3+1]);
    outtextxy(xm-155,y1+50,dtext[k3+2]);
    outtextxy(xm-155,y1+60,dtext[k3+3]);
  end;
  if mauswahl(xm+147,y1+24,xm+160,y1+38,1) then begin
   if k3=1 then piep else begin k2:=0;k3:=k3-1;end;
   while mauskey>0 do;end;
  if mauswahl(xm+147,y1+57,xm+160,y1+71,1) then begin
   if k3=ende then piep else begin k2:=0;k3:=k3+1;end;
   while mauskey>0 do;end;
 until mauswahl(xm-48,y1+75,xm+48,y1+95,1);
 mauson(false);putimage(xm-170,y1,pufa^,0);freemem(pufa,k);
 mauson(true);while mauskey>0 do;setcolor(col);
end;

{----------------------------------------------------------------------}

 procedure wahl(xm,y1:word;HF,SF:BYTE;text:string;var k3:BYTE);
  var k2,col,j:byte;
      k:word;
      pufa:pointer;
  begin
   k:=imagesize(xm-170,y1,xm+170,y1+90);mauson(false);col:=getcolor;
   getmem(pufa,k);getimage(xm-170,y1,xm+170,y1+90,pufa^);
   open_window(xm-170,y1,xm+170,y1+90,HF,SF,HF,text);mauson(false);
   setcolor(0);rectangle(xm-101,y1+24,xm+101,y1+41);
   box(xm+127,y1+40,xm+140,y1+54,HF,1,false);outtextxy(xm+130,y1+44,chr(24));
   box(xm+127,y1+66,xm+140,y1+80,HF,1,false);outtextxy(xm+130,y1+70,chr(25));
   box(xm-48,y1+60,xm+48,y1+80,HF,1,false);outtextxy(xm-40,y1+67,'alles klar');
   mauson(true);setzmaus(xm,y1+45);k2:=0;k3:=1;setfillstyle(1,15);
   repeat
    if k2=0 then
     begin
      bar(xm-100,y1+25,xm+100,y1+40);k2:=1;
      outtextxy(xm-length(staerke[k3])*4,y1+30,staerke[k3]);
    end;
    if mauswahl(xm+127,y1+40,xm+140,y1+54,1) then begin
     if k3=1 then piep else begin k2:=0;k3:=k3-1;end;
     while mauskey>0 do;end;
    if mauswahl(xm+127,y1+66,xm+140,y1+80,1) then begin
     if k3=10 then piep else begin k2:=0;k3:=k3+1;end;
     while mauskey>0 do;end;
   until mauswahl(xm-48,y1+60,xm+48,y1+80,1);
   mauson(false);putimage(xm-170,y1,pufa^,0);freemem(pufa,k);
   mauson(true);while mauskey>0 do;setcolor(col);
  end;

{----------------------------------------------------------------------}

procedure feldnr(xm,y1:word;HF,SF:BYTE;text:string;var k3:BYTE);
var k2,col,j:byte;
      k:word;
      pufa:pointer;
  begin
   k:=imagesize(xm-170,y1,xm+170,y1+90);mauson(false);col:=getcolor;
   getmem(pufa,k);getimage(xm-170,y1,xm+170,y1+90,pufa^);
   open_window(xm-170,y1,xm+170,y1+90,HF,SF,HF,text);mauson(false);
   setcolor(0);rectangle(xm-101,y1+24,xm+101,y1+41);
   box(xm+127,y1+40,xm+140,y1+54,HF,1,false);outtextxy(xm+130,y1+44,chr(24));
   box(xm+127,y1+66,xm+140,y1+80,HF,1,false);outtextxy(xm+130,y1+70,chr(25));
   box(xm-48,y1+60,xm+48,y1+80,HF,1,false);outtextxy(xm-40,y1+67,'alles klar');
   mauson(true);setzmaus(xm,y1+45);k2:=0;k3:=1;setfillstyle(1,15);
   repeat
    if k2=0 then
     begin
      bar(xm-100,y1+25,xm+100,y1+40);k2:=1;
      outtextxy(xm-length(feldgr[k3])*4,y1+30,feldgr[k3]);
    end;
    if mauswahl(xm+127,y1+40,xm+140,y1+54,1) then begin
     if k3=1 then piep else begin k2:=0;k3:=k3-1;end;
     while mauskey>0 do;end;
    if mauswahl(xm+127,y1+66,xm+140,y1+80,1) then begin
     if k3=7 then piep else begin k2:=0;k3:=k3+1;end;
     while mauskey>0 do;end;
   until mauswahl(xm-48,y1+60,xm+48,y1+80,1);
   mauson(false);putimage(xm-170,y1,pufa^,0);freemem(pufa,k);
   mauson(true);while mauskey>0 do;setcolor(col);
  end;

{----------------------------------------------------------------------}

function auswahl(xm,y1:word;text1,text2,text3,antw1,antw2:string;Hfarbe,Sfarbe,wo:Byte):char;
var an,diff,hoehe,col,k,k2:word;
    pufa:pointer;
    aw1,aw2:string;
    Links,Rechts:Boolean;
begin
 col:=getcolor;k:=2*length(antw1)+5;
 if length(antw1)<length(antw2) then k:=2*length(antw2)+5;
 aw1:=antw1;aw2:=antw2;
 if length(aw1)<length(aw2) then
  begin
   diff:=length(aw2)-length(aw1);
   an:=diff div 2;
   aw1:=copy(space,1,an)+aw1+copy(space,1,an);
   if odd(diff) then aw1:=copy(space,1,1)+aw1
  end;
 if length(aw2)<length(aw1) then
  begin
   diff:=length(aw1)-length(aw2);
   an:=diff div 2;
   aw2:=copy(space,1,an)+aw2+copy(space,1,an);
   if odd(diff) then aw2:=copy(space,1,1)+aw2
  end;
 if length(text1)>k then k:=length(text1);
 if length(text2)>k then k:=length(text2);
 if length(text3)>k then k:=length(text3);
 k2:=k;mauson(false);hoehe:=38;
 if length(text2)>0 then inc(hoehe,12);
 if length(text3)>0 then inc(hoehe,12);
 k:=imagesize(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1);
 getmem(pufa,k);getimage(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,pufa^);
 box(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,Hfarbe,1,true);
 box(xm-(4*k2)-15,y1+2,xm+(4*k2)+15,y1+hoehe-2,Hfarbe,2,false);
 setcolor(Sfarbe);outtextxy(xm-length(text1)*4,y1+6,text1);
 if text2<>'' then outtextxy(xm-length(text2)*4,y1+18,text2);
 if text3<>'' then outtextxy(xm-length(text3)*4,y1+30,text3);
 box(xm-length(aw1)*8-24,y1+hoehe-22,xm-8,y1+hoehe-5,Hfarbe,1,false);
 outtextxy(xm-length(aw1)*8-16,y1+hoehe-17,aw1);
 box(xm+8,y1+hoehe-22,xm+length(aw2)*8+24,y1+hoehe-5,Hfarbe,1,false);
 outtextxy(xm+16,y1+hoehe-17,aw2);
 mauson(true);WHILE MausKey<>0 DO;
 setzmaus(xm+length(aw2)*4+8,y1+hoehe-15);
 if wo=0 then setzmaus(xm,y1+hoehe-15);
 if wo=1 then setzmaus(xm-length(aw1)*4-8,y1+hoehe-15);
 auswahl:=#27; { ESC mit der rechten Maustaste }
 repeat
  Links:=mauswahl(xm-length(aw1)*8-24,y1+hoehe-22,xm-8,y1+hoehe-5,1);
  Rechts:=mauswahl(xm+8,y1+hoehe-22,xm+length(aw2)*8+24,y1+hoehe-5,1)
 until Links or Rechts or (mauskey=2);
 mauson(false);
 if Links then
  begin
   auswahl:=antw1[1];
   box(xm-length(aw1)*8-24,y1+hoehe-22,xm-8,y1+hoehe-5,Hfarbe,2,false);
  end;
 if Rechts then
  begin
   auswahl:=antw2[1];
   box(xm+8,y1+hoehe-22,xm+length(aw2)*8+24,y1+hoehe-5,Hfarbe,2,false);
  end;
 setcolor(col);delay(1000);
 putimage(xm-(4*k2)-20,y1-1,pufa^,0);freemem(pufa,k);mauson(true);
 WHILE MausKey<>0 DO;
end;

{----------------------------------------------------------------------}

procedure weiter(x1,y1:word;Hfarbe,Sfarbe:byte);
var col,k:word;
    pufa:pointer;
begin
 k:=imagesize(x1,y1,x1+64,y1+24);mauson(false);col:=getcolor;
 getmem(pufa,k);getimage(x1,y1,x1+64,y1+24,pufa^);
 box(x1,y1,x1+64,y1+24,Hfarbe,1,true);
 setcolor(Sfarbe);outtextxy(x1+8,y1+8,'Weiter');
 mauson(true);setzmaus(x1+32,y1+12);WHILE MausKey<>0 DO;
 repeat until mauswahl(x1,y1,x1+64,y1+24,1);
 mauson(false);box(x1,y1,x1+64,y1+24,Hfarbe,4,false);
 putimage(x1,y1,pufa^,0);freemem(pufa,k);setcolor(col);
 WHILE MausKey<>0 DO;
end;

{----------------------------------------------------------------------}

FUNCTION FragText(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte;buch:charset):TXT70;
var k,k2,col,hoehe:word;
    pufa:pointer;
    EINTEXT:TXT70;

BEGIN
 col:=getcolor;k:=max+1;
 if length(text1)>k then k:=length(text1);
 if length(text2)>k then k:=length(text2);
 if length(text3)>k then k:=length(text3);
 k2:=k;mauson(false);hoehe:=38;
 if length(text2)>0 then inc(hoehe,12);
 if length(text3)>0 then inc(hoehe,12);
 k:=imagesize(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1);
 getmem(pufa,k);getimage(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,pufa^);
 box(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,Hfarbe,1,true);
 box(xm-(4*k2)-15,y1+2,xm+(4*k2)+15,y1+hoehe-2,Hfarbe,2,false);
 setcolor(Sfarbe);outtextxy(xm-length(text1)*4,y1+6,text1);
 if text2<>'' then outtextxy(xm-length(text2)*4,y1+18,text2);
 if text3<>'' then outtextxy(xm-length(text3)*4,y1+30,text3);
 box(xm-(4*k2),y1+hoehe-20,xm-(4*k2)+8*max+4,y1+hoehe-8,Hfarbe,1,false);
 REPEAT
  EINTEXT:=eingabe(xm-(4*k2)+3,y1+hoehe-17,max,buch);
 UNTIL LENGTH(EINTEXT)>0;
 fragText:=EINTEXT;
 MausOn(False); PutImage(xm-(4*k2)-20,y1-1,pufa^,NormalPut);
 FreeMem(pufa,k);
 MausOn(True);setcolor(col);
END;

{----------------------------------------------------------------------}

FUNCTION FragInt(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte):Integer;
VAR txt    : TXT70;
    i,code : Integer;
BEGIN
 REPEAT
  txt:=FragText(xm,y1,text1,text2,text3,Hfarbe,Sfarbe,max,['0'..'9','-']);
  Val(txt,i,code);
 UNTIL CODE=0;
 FragInt:=i;
END;

{----------------------------------------------------------------------}

FUNCTION FragReal(xm,y1:Integer;text1,text2,text3:txt70;HF,SF:BYTE;max:Word;VAR ok:Boolean):Real;
VAR txt    : txt70;
    code   : Integer;
    r      : Real;
BEGIN
  txt:=FragText(xm,y1,text1,text2,text3,HF,SF,max,['0'..'9','-','.']);
  IF (Length(txt)=0) Or (txt[1]=#27) THEN ok:=false
  ELSE BEGIN
    Val(txt,r,code);
    IF code=0 THEN ok:=true ELSE ok:=false;
  END;
  FragReal:=r;
END;

{----------------------------------------------------------------------}

PROCEDURE GText(x,y,tf,hf:Integer;txt:TXT70);
                         (* tf: Textfarbe, hf: Hintergrundfarbe *)
VAR h,l,c,cs,cx,cy : Integer;
    filli          : FillSettingsType;
    txti           : TextSettingsType;
BEGIN
  IF txt='' THEN Exit;
  cx:=GetX; cy:=GetY;
  GetFillSettings(filli); GetTextSettings(txti); cs:=txti.CharSize;
  h:=TextHeight(txt);  l:=TextWidth(txt);  c:=GetColor;
  IF txti.Direction=VertDir THEN Swap(h,l);
  SetFillStyle(SolidFill,hf);
  IF txti.Direction=HorizDir THEN
    CASE txti.Font OF
      0:   Bar(x-1,y-1,x+l-1,y+h-1);
      2:   Bar(x-1,y+sfontdy[cs]-1,x+l,y+sfontdy[cs]+h);
      ELSE Bar(x-1,y+fontdy[cs]-1,x+l,y+fontdy[cs]+h);
    END
  ELSE
    CASE txti.Font OF
      0:   Bar(x-l-1,y-h-1,x,y);
      2:   Bar(x+sfontdy[cs]-1,y-h,x+l+sfontdy[cs],y+1);
      ELSE Bar(x+fontdy[cs]-1,y-h,x+l+fontdy[cs],y+1);
    END;
  SetFillStyle(filli.pattern,filli.color);
  SetColor(tf); OutTextXY(x,y,txt); SetColor(c);
  MoveTo(cx,cy);
END;

{----------------------------------------------------------------------}

FUNCTION GRead2(xa,ya,xe,ye,x,y,tf,hf,st:Integer;zeichen:charset):TXT70;
  VAR c                 : Char;
      txt               : TXT70;
      cpos,len,wx,wy,x1 : Word;
      mkey              : Integer;
 BEGIN
  zeichen:=zeichen+[#13];
  wx:=TextWidth('0'); wy:=TextHeight('0');
  txt[0]:=Chr(st); FillChar(txt[1],st,' ');
  MausOn(False); GText(x,y,hf,hf,txt);
  txt:=''; c:=#0; len:=1;
  REPEAT
    cpos:=len;x1:=x+(cpos-1)*wx;
    MausOn(False);GText(x1,y,tf,hf,txt[cpos]);
    REPEAT
     c:=#0;
     CursorBlinken(x1-1,y-1,x1+wx-1,y+wy-1,blinkstop);
     mkey:=MausKey;
     IF mkey=0 THEN c:=ReadKey;
    UNTIL C in zeichen;
   IF c<>#13 THEN
    BEGIN MausOn(False);GText(x1,y,tf,hf,'*'); txt[len]:=c;Inc(len) END
  UNTIL (c=#13) OR (LEN>ST);
  txt[0]:=Chr(len-1);
  GRead2:=txt;MausOn(True);
END;

function eingabe2(x1,y1,max:word;art:charset):string;
begin
 eingabe2:=gread2(x1,y1,x1+8*max,y1+8,x1,y1,0,7,max,art);
end;

{----------------------------------------------------------------------}

FUNCTION FragText2(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte;buch:charset):TXT70;
var k,k2,col,hoehe:word;
    pufa:pointer;
    EINTEXT:TXT70;

BEGIN
 col:=getcolor;k:=max+1;
 if length(text1)>k then k:=length(text1);
 if length(text2)>k then k:=length(text2);
 if length(text3)>k then k:=length(text3);
 k2:=k;mauson(false);hoehe:=38;
 if length(text2)>0 then inc(hoehe,12);
 if length(text3)>0 then inc(hoehe,12);
 k:=imagesize(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1);
 getmem(pufa,k);getimage(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,pufa^);
 box(xm-(4*k2)-20,y1-1,xm+(4*k2)+20,y1+hoehe+1,Hfarbe,1,true);
 box(xm-(4*k2)-15,y1+2,xm+(4*k2)+15,y1+hoehe-2,Hfarbe,2,false);
 setcolor(Sfarbe);outtextxy(xm-length(text1)*4,y1+6,text1);
 if text2<>'' then outtextxy(xm-length(text2)*4,y1+18,text2);
 if text3<>'' then outtextxy(xm-length(text3)*4,y1+30,text3);
 box(xm-(4*k2),y1+hoehe-20,xm-(4*k2)+8*max+4,y1+hoehe-8,Hfarbe,1,false);
 REPEAT
  EINTEXT:=eingabe2(xm-(4*k2)+3,y1+hoehe-17,max,buch);
 UNTIL LENGTH(EINTEXT)>0;
 fragText2:=EINTEXT;
 MausOn(False); PutImage(xm-(4*k2)-20,y1-1,pufa^,NormalPut);
 FreeMem(pufa,k);
 MausOn(True);setcolor(col);
END;

{----------------------------------------------------------------------}

FUNCTION FragInt2(xm,y1:Integer;text1,text2,text3:TXT70;Hfarbe,Sfarbe,max:Byte):LONGINT;
VAR txt    : TXT70;
    code : Integer;
    I:LONGINT;
BEGIN
 REPEAT
  txt:=FragText2(xm,y1,text1,text2,text3,Hfarbe,Sfarbe,max,['0'..'9','-']);
  Val(txt,i,code);
 UNTIL CODE=0;
 FragInt2:=i;
END;

{----------------------------------------------------------------------}

PROCEDURE MenuInit(x1k,y1k,x2k,HINTERGRUNDFARBE,TEXTFARBE:integer;VAR menutxt;s,p,l:Word);
CONST leer                : String = '                     ';
VAR i,j,k,ty,tx,x1,y1,
    col,max,len,len1,len2 : Word;
    puf                   : ^txt70;
BEGIN
  menu.ihf:=HINTERGRUNDFARBE; menu.ivf:=TEXTFARBE;
  SetTextStyle(0,0,1);
  ty:=TextHeight('X'); tx:=TextWidth('X');
  If s>maxseiten THEN s:=maxseiten;
  WITH menu.balken DO BEGIN
    xa:=x1k; ya:=y1k; xe:=x2k; ye:=ya+ty+7; x1:=xa; y1:=ye+1;
    size:=ImageSize(xa,ya,xe,ye); GetMem(grund,size);
  END;
  puf:=@menutxt;
  WITH menu DO BEGIN
    seitenzahl:=s;
    FOR i:=1 TO s DO BEGIN
      New(seite[i]);
      WITH menu.seite[i]^ DO BEGIN
        xa:=x1; ya:=y1;
        titel:=puf^; puf:=@puf^[l+1];
        max:=Length(titel);
        txa:=xa+4; tya:=menu.balken.ya+4;
        txe:=txa+max*tx+1; tye:=menu.balken.ye;
        FOR k:=1 TO p DO BEGIN
          New(punkt[k]);
          punkt[k]^:=puf^; puf:=@puf^[l+1];
          len:=Length(punkt[k]^);
          IF len<>0 THEN BEGIN
            punkt[k]^:=' '+punkt[k]^; Inc(len); punktzahl:=k;
          END;
          IF max<len THEN max:=len;
        END;
        xe:=xa+max*tx+6;
        ye:=ya+punktzahl*(ty+1)+2;
        FOR j:=1 TO punktzahl DO BEGIN
          WITH menu.seite[i]^ DO BEGIN
            pxa[j]:=xa+4; pya[j]:=ya+(ty+5)*(j-1)+5;
            pxe[j]:=xe-4; pye[j]:=pya[j]+ty+1;
            len:=Length(punkt[j]^);
            len1:=(max-len+1) Div 2; len2:=max-len-len1;
            punkt[j]^:=
              Concat(Copy(leer,1,len1),punkt[j]^,Copy(leer,1,len2));
          END;                END;
        size:=ImageSize(xa,ya,xe,ye+l*4+2); GetMem(grund,size);
        x1:=x1+(Length(titel)+2)*tx+1;
      END;
    END;
  END;
END;

{----------------------------------------------------------------------}

PROCEDURE ChangeMenu(snr,pnr:byte;text1:string);
begin
 with menu.seite[snr]^ do
  punkt[pnr]^:=text1;
end;

{----------------------------------------------------------------------}

PROCEDURE ShowMenu;
VAR i:integer;
BEGIN
  SetTextStyle(0,0,1);SetTextJustify(LeftText,TopText);
  SetFillStyle(SolidFill,menu.ihf); SetLineStyle(SolidLn,0,NormWidth);
  MausOn(False);
  WITH menu DO BEGIN
    WITH balken DO box(xa,ya,xe,ye,menu.ihf,1,true);
    FOR i:=1 TO seitenzahl DO WITH seite[i]^ DO
      GText(txa,tya,menu.ivf,menu.ihf,titel);
  END;
  MausOn(True);
END;

{----------------------------------------------------------------------}

PROCEDURE MenuFree;
VAR i,j : Word;
BEGIN
  WITH menu DO BEGIN
    WITH balken DO FreeMem(grund,size);
    FOR i:=1 TO seitenzahl DO BEGIN
      WITH seite[i]^ DO BEGIN
        FreeMem(grund,size);
        FOR j:=1 TO punktzahl DO Dispose(punkt[j]);
      END;
      Dispose(seite[i]);
    END;
  END;
END;

{----------------------------------------------------------------------}

PROCEDURE MenuMark(snr,pnr:Integer);
BEGIN
  WITH menu.seite[snr]^ DO
    IF punkt[pnr]^[1]=#62 THEN punkt[pnr]^[1]:=#32;
END;

{----------------------------------------------------------------------}

PROCEDURE MenuWahl(VAR snr,pnr:Integer);
VAR col,i           : Word;
    taste1,taste2 : Char;
(* .................................................................. *)
PROCEDURE SeitenWechsel(d:Integer);
BEGIN
  MausOn(False);
  WITH menu.seite[snr]^ DO
    box(txa-3,tya-3,txa+3+8*length(titel),tya+10,menu.ihf,4,false);
  snr:=((snr+d-1)+menu.seitenzahl) Mod menu.seitenzahl +1;
  WITH menu.seite[snr]^ DO
    GText(txa,tya,menu.ivf,menu.ihf,titel);
  MausOn(True);
END;
(* .................................................................. *)
PROCEDURE PunktWechsel(d:Integer);
BEGIN
  MausOn(False);
  WITH menu.seite[snr]^ DO BEGIN
    GText(pxa[pnr],pya[pnr],menu.ivf,menu.ihf,punkt[pnr]^);
    pnr:=((pnr+d-1)+punktzahl) Mod punktzahl +1;
  END;
  WITH menu.seite[snr]^ DO
    GText(pxa[pnr],pya[pnr],menu.ivf,menu.ihf,punkt[pnr]^);
  MausOn(True);
END;
(* .................................................................. *)
PROCEDURE ZeigSeite(n:Integer);
VAR i : Integer;
BEGIN
  MausOn(False);
  WITH menu.seite[n]^ DO BEGIN
    box(txa-3,tya-3,txa+3+8*length(titel),tya+10,menu.ihf,2,false);
    GetImage(xa,ya,xe,ye+punktzahl*4+2,grund^);
    box(xa,ya,xe,ye+punktzahl*4+2,menu.ihf,1,true);
    FOR i:=1 TO punktzahl DO
     GText(pxa[i],pya[i],menu.ivf,menu.ihf,punkt[i]^);
    MausOn(True);
    WHILE MausWahl(txa,menu.balken.ya,txe,menu.balken.ye,1) DO;
  END;
END;
(* .................................................................. *)
PROCEDURE LoeschSeite(n:Integer);
BEGIN
  MausOn(False);
  WITH menu.seite[n]^ DO BEGIN
    box(txa-3,tya-3,txa+3+8*length(titel),tya+10,menu.ihf,2,false);
    PutImage(xa,ya,grund^,NormalPut);
  END;
  MausOn(True);
END;
(* .................................................................. *)
PROCEDURE MausPunktWahl;
VAR n,altn  : Integer;
    punktan : Boolean;
    extra : string;
BEGIN
  ZeigSeite(snr);  altn:=0;
  WITH menu.seite[snr]^ DO BEGIN
    WHILE MausWahl(txa,menu.balken.ya,pxe[1],GetMaxY,1) DO BEGIN
      REPEAT
          punktan:=False; n:=1;
        WHILE Not punktan And (n<=punktzahl) DO BEGIN
          punktan:=MausWahl(pxa[n],pya[n],pxe[n],pye[n],1);
          Inc(n);
        END;
      UNTIL punktan Or
            Not MausWahl(txa,menu.balken.ye,pxe[1],GetMaxY,1);
      IF punktan THEN BEGIN pnr:=n-1;
        MausOn(False);
        extra:=copy(punkt[pnr]^,1,2);
        if not ((extra='  ')or(extra=' -')or(extra=' ')) then
           box(pxa[pnr]-2,pya[pnr]-3,pxa[pnr]+8*length(punkt[pnr]^),pya[pnr]+10,menu.ihf,1,false);
        MausOn(True); altn:=pnr;
        WHILE MausWahl(pxa[pnr],pya[pnr],pxe[pnr],pye[pnr],1) DO;
        IF altn>0 THEN BEGIN
          MausOn(False);
          box(pxa[altn]-2,pya[altn]-3,pxa[altn]+8*length(punkt[altn]^),pya[altn]+10,menu.ihf,4,TRUE);
          GText(pxa[ALTN],pya[ALTN],menu.ivf,menu.ihf,punkt[ALTN]^);
          MausOn(True);
        END;
      END ELSE pnr:=-1;
    END;
    IF Not MausIn(txa,menu.balken.ye,pxe[1],GetMaxY) THEN pnr:=-1;
  END;
  LoeschSeite(snr);SHOWMENU
END;
(* .................................................................. *)
PROCEDURE MausSteuerung;
VAR n       : Integer;
    seitean : Boolean;
BEGIN
  snr:=-1; pnr:=-1;
  WITH menu DO REPEAT
    REPEAT
      seitean:=False; n:=1;
      WHILE Not seitean And (n<=seitenzahl) DO BEGIN
        WITH seite[n]^ DO seitean:=MausWahl(txa,tya-2,txe,tye,1);
        inc(n);
      END;
      IF seitean THEN BEGIN snr:=n-1; MausPunktWahl;
      END ELSE IF pnr<1 THEN snr:=-1;
    UNTIL MausKey=0;
    IF pnr<1 THEN WHILE MausKey=0 DO;
  UNTIL ((MausKey>0) And
          Not MausIn(balken.xa,balken.ya,balken.xe,balken.ye)) Or (pnr>=0);
END;

{----------------------------------------------------------------------}
                                                            { MenuWahl }
 BEGIN SHOWMENU;MausSteuerung END;

{----------------------------------------------------------------------}

procedure piep;
 begin sound(1000);delay(300);nosound end;
end.
