{$R+,G+,Q+}
{$M 64000,0,640000}
PROGRAM REVERSI_V13;
 USES CRT,DOS,MAUS,GRAPH,GRINI,GRAPH5;

 CONST MAXNR=32;GROESSE=8;

 TYPE  BELEGUNG =(RAND,LEER,MENSCH,COMPUTER);
                 { 0  , 1  ,  2   ,   3    }
       SPIELER  =MENSCH..COMPUTER;
       SPIELFELD=ARRAY[0..99] OF BELEGUNG;
       SPIELZUG =BYTE;
       SPIELZUGLISTE=ARRAY[1..MAXNR] OF SPIELZUG;
       MASKTYPE=ARRAY[0..1,0..15]OF WORD;
       MASKRECORD=RECORD MASK:MASKTYPE;X,Y:WORD END;

 CONST WEITE:ARRAY[1..8]OF SHORTINT=(-11,-10,-9,-1,1,9,10,11);
       GEGNER:ARRAY[MENSCH..COMPUTER]OF SPIELER=(COMPUTER,MENSCH);
       MININT=-30000;MAXINT=30000;TEIL=12;
       KANN_NICHT:ARRAY[SPIELER]OF INTEGER=(3000,-3000);
       SEITENZAHL=3;PUNKTZAHL=4;MAXLEN=20;KNOPF=LIGHTGREEN;
       BW8:ARRAY[0..99]OF INTEGER=
         (0,  0,   0, 0, 0, 0, 0,   0,   0,0,
          0,900, -40,40,30,30,40, -40, 900,0,
          0,-40,-400, 2, 1, 1, 2,-400, -40,0,
          0, 40,   2, 5, 2, 2, 5,   2,  40,0,
          0, 30,   1, 2, 2, 2, 2,   1,  30,0,
          0, 30,   1, 2, 2, 2, 2,   1,  30,0,
          0, 40,   2, 5, 2, 2, 5,   2,  40,0,
          0,-40,-400, 2, 1, 1, 2,-400, -40,0,
          0,900, -40,40,30,30,40, -40, 900,0,
          0,  0,   0, 0, 0, 0, 0,   0,   0,0);
       LEERTASTE='                                      ';
       ANLEITUNGSTEXT:ARRAY[1..20]OF STRING[35]=
        ('Jeder Spieler hat Spielmarken','seiner Farbe. Abwechselnd wird',
         'gezogen. Ein Zug besteht darin,','eine Spielmarke so auf ein leeres',
         'Spielfeld zu setzen, da mindestens','eine Marke eingeschlossen wird.',
         'Alle waagerecht, senkrecht und','diagonal eingeschlossenen Marken',
         'des Gegners bekommen die Farbe des','Spielers, der am Zug ist. Kann kein',
         'Spieler mehr ziehen, ist die Partie','zu Ende. Sieger ist derjenige, der',
         'mehr eigene Steine hat.','','','','','','','');
       MENUTEXT:
         ARRAY[1..SEITENZAHL,0..PUNKTZAHL]OF STRING[MAXLEN]=
         (('  '+#240+'  ','Info      ','Anleitung ','',''),
         ('Service ','Zug zurcknehmen   ','Zugvorschlag       ','Spielstrke ndern ','Felder markieren   '),
         ('Spielkram ','Cursor ndern       ','Zugbewertung an/aus ','',''));

 STANDARDCURSOR:MASKRECORD
                =(MASK:(($3FFF,$1FFF,$FFF ,$7FF ,$3FF ,$1FF ,$FF  ,$7F  ,
                         $3F  ,$1F  ,$1FF ,$10FF,$30FF,$F87F,$F87F,$FC3F),
                        ($0   ,$4000,$6000,$7000,$7800,$7C00,$7E00,$7F00,
                         $7F80,$7FC0,$7C00,$4600,$600 ,$300 ,$300 ,$180 ));
                         X:0;Y:0);
   FINGERCURSOR:MASKRECORD
                =(MASK:(($8FFF,$83FF,$C1FF,$E07F,$F03F,$E007,$C003,$8003,
                         $0001,$0001,$8000,$C000,$E000,$F001,$FC01,$FE03),
                        ($0000,$3000,$1C00,$0600,$0380,$0D00,$16F8,$19E8,
                         $6C1C,$33DC,$0FDC,$1F6E,$0FBE,$03BC,$01BC,$0000));
                         X:1;Y:0);
 HOURGLASSCURSOR:MASKRECORD
                =(MASK:(($0   ,$0   ,$0   ,$0   ,$8001,$C003,$E007,$F00F,
                         $E007,$C003,$8001,$0   ,$0   ,$0   ,$0   ,$FFFF),
                        ($0   ,$7FFE,$6006,$300C,$1818,$C30 ,$660 ,$3C0 ,
                         $660 ,$C30 ,$1998,$33CC,$67E6,$7FFE,$0   ,$0   ));
                         X:7;Y:7);

 VAR  FELD:SPIELFELD;
      GLOBAL_LISTE:SPIELZUGLISTE;
      GLOBAL_AN:BYTE;
      CH:CHAR;
      SPIELER1,SPIELER2,TSTR:STRING;
      TEILE:ARRAY[0..9]OF POINTER;
      BW:ARRAY[0..99]OF INTEGER;
      HINTERGRUND,SCHRIFT,K,RADIUS,BREITE,ZUGNUMMER,TIEFE,LEVEL:BYTE;
      SEITE,PUNKT:INTEGER;
      FARBE:ARRAY[1..3]OF BYTE;
      COUNT:LONGINT;
      DRANWAHL,DRAN:SPIELER;
      ALTCURSOR,CURSOR:MASKRECORD;
      SPIEL:ARRAY[0..64]OF SPIELFELD;
      ANZEIGEN,ZEIGEN,DRAUSSEN,ABBRUCH,NEHMEN,ZWEISPIELERMODUS:BOOLEAN;
{****************************************************************************}
{*                         AUSGABE DES SPIELFELDES                          *}
{****************************************************************************}
 PROCEDURE FELDAUSGABE;
  VAR K,L:BYTE;
      X,Y:WORD;
  BEGIN
   MAUSON(FALSE);
   BOX(BREITE-5,2*BREITE-5,ROUND(9*BREITE)+5,10*BREITE+7,HINTERGRUND,1,TRUE);
   FOR K:=1 TO GROESSE DO
    FOR L:=1 TO GROESSE DO
     BEGIN
      X:=BREITE DIV 2+L*BREITE;Y:=(K+1)*BREITE+BREITE DIV 2;
      SETCOLOR(SCHRIFT);CIRCLE(X,Y,RADIUS);
      SETFILLSTYLE(SOLIDFILL,SCHRIFT);FLOODFILL(X,Y,SCHRIFT);
     END;
   FOR K:=1 TO GROESSE DO
    BEGIN
     X:=BREITE DIV 2+K*BREITE;Y:=BREITE+BREITE DIV 2;
     GTEXT(X,Y,SCHRIFT,HINTERGRUND,CHAR(64+K));
     Y:=BREITE*(GROESSE+2)+BREITE DIV 2;
     GTEXT(X,Y,SCHRIFT,HINTERGRUND,CHAR(64+K));
    END;
   FOR K:=1 TO GROESSE DO
    BEGIN
     Y:=BREITE DIV 2+(K+1)*BREITE;X:=BREITE DIV 2;
     GTEXT(X,Y,SCHRIFT,HINTERGRUND,CHAR(48+K));
     X:=BREITE*(GROESSE+1)+BREITE DIV 2-8;
     GTEXT(X,Y,SCHRIFT,HINTERGRUND,CHAR(48+K));
    END;
  END;
{****************************************************************************}
{*                         NDERUNGEN DES SPIELFELDES                       *}
{****************************************************************************}
 PROCEDURE SPIELFELDAUSGABE(SF:SPIELFELD);
  VAR K,L,BREITE,WO:BYTE;
      X,Y:WORD;
  BEGIN
   BREITE:=(MAXY+1) DIV TEIL;MAUSON(FALSE);
   FOR K:=1 TO GROESSE DO
    FOR L:=1 TO GROESSE DO
     BEGIN
      WO:=K*10+L;X:=K*BREITE;Y:=(L+1)*BREITE;
      IF SF[WO]=COMPUTER THEN PUTIMAGE(X,Y,TEILE[0]^,NORMALPUT);
      IF SF[WO]=MENSCH   THEN PUTIMAGE(X,Y,TEILE[9]^,NORMALPUT);
      IF SF[WO]=LEER THEN
       BEGIN
        SETFILLSTYLE(SOLIDFILL,SCHRIFT);
        FLOODFILL(X+RADIUS,Y+RADIUS,HINTERGRUND)
       END;
     END;
   MAUSON(TRUE)
  END;

{ PROCEDURE UMDREHEN(VAR NEU:SPIELFELD;AMZUG:SPIELER;ZUG:SPIELZUG);
  VAR SCHRITT,I,WO,ALTWO:SHORTINT;
      G:SPIELER;
  BEGIN
   G:=GEGNER[AMZUG];NEU[ZUG]:=AMZUG;
   FOR I:=1 TO 8 DO
    BEGIN
     SCHRITT:=WEITE[I];WO:=ZUG+SCHRITT;ALTWO:=WO;
     WHILE NEU[WO]=G DO INC(WO,SCHRITT);
     IF (NEU[WO]=AMZUG) AND (WO<>ALTWO) THEN
      BEGIN
       DEC(WO,SCHRITT);
       WHILE WO<>ZUG DO BEGIN NEU[WO]:=AMZUG;DEC(WO,SCHRITT) END
      END
    END
  END;}

 PROCEDURE UMDREHEN(VAR NEU:SPIELFELD;AMZUG:SPIELER;ZUG:SPIELZUG);
  BEGIN
   ASM
            PUSH DS                { ALTWO   EQU AH }
            MOV CH,AMZUG           { I       EQU BH }
            MOV BL,ZUG             { ZUG     EQU BL }
            MOV BH,0               { AMZUG   EQU CH }
            LDS DI,NEU             { G       EQU CL }
            MOV SI,OFFSET @WEITE   { WO      EQU DH }
                                   { SCHRITT EQU DL }
            MOV CL,5               { MENSCH+COMPUTER }
            SUB CL,CH
            PUSH DI
            ADD DI,BX
            MOV [DI],CH
            POP DI
            MOV BH,8
    @FORI:  MOV DL,CS:[SI]
            MOV DH,DL
            ADD DH,BL
            MOV AH,DH
    @WHILE1:PUSH DI
            PUSH BX
            MOV BL,DH
            MOV BH,0
            ADD DI,BX
            MOV AL,[DI]
            POP BX
            POP DI
            CMP AL,CL
            JNE @RAUS
            ADD DH,DL
            JMP @WHILE1
    @RAUS:  CMP DH,AH
            JE @ENDE
            PUSH DI
            PUSH BX
            MOV BL,DH
            MOV BH,0
            ADD DI,BX
            MOV AL,[DI]
            POP BX
            POP DI
            CMP AL,CH
            JNE @ENDE
            SUB DH,DL
   @WHILE2: CMP DH,BL
            JE @ENDE
            PUSH DI
            PUSH BX
            MOV BL,DH
            MOV BH,0
            ADD DI,BX
            MOV [DI],CH
            POP BX
            POP DI
            SUB DH,DL
            JMP @WHILE2
    @ENDE:  INC SI
            DEC BH
            JNE @FORI
            POP DS
            JMP @FINE
   @WEITE:  DB -11,-10,-9,-1,1,9,10,11
   @FINE:
   END
  END;

{ PROCEDURE GENZUGLISTE(VAR SF:SPIELFELD;AMZUG:SPIELER;VAR N:BYTE;VAR ZL:SPIELZUGLISTE);
  CONST FOLGE:ARRAY[1..60]OF BYTE=(11,18,81,88,12,13,14,15,
                                   16,17,21,31,41,51,61,71,
                                   28,38,48,58,68,78,82,83,
                                   84,85,86,87,22,23,24,25,
                                   26,27,37,47,57,67,77,76,
                                   75,74,73,72,62,52,42,32,
                                   33,34,35,36,46,56,66,65,
                                   64,63,53,43);
  VAR NR,SCHRITT,I,J,WO,ALTWO:SHORTINT;
      G:SPIELER;
  BEGIN
   G:=GEGNER[AMZUG];N:=0;
   FOR I:=1 TO 60 DO
    BEGIN
     NR:=FOLGE[I];
     IF SF[NR]=LEER THEN
      BEGIN
       FOR J:=1 TO 8 DO
        BEGIN
         SCHRITT:=WEITE[J];WO:=NR+SCHRITT;ALTWO:=WO;
         WHILE SF[WO]=G DO INC(WO,SCHRITT);
         IF (SF[WO]=AMZUG) AND (WO<>ALTWO) THEN
          BEGIN INC(N);ZL[N]:=NR;BREAK END
        END;
      END
    END
  END;}

 PROCEDURE GENZUGLISTE(VAR SF:SPIELFELD;AMZUG:SPIELER;VAR N:BYTE;VAR ZL:SPIELZUGLISTE);
  BEGIN
   ASM
             PUSH DS
             PUSH BP
             MOV CH,AMZUG
             MOV CL,5
             SUB CL,CH
             LDS DI,SF
             LES SI,ZL
             PUSH SI
             MOV BP,OFFSET @INDEX
             MOV BH,60
    @FORI:   PUSH BX
             PUSH SI
             MOV SI,OFFSET @WEITE
             MOV BH,0
             MOV BL,CS:[BP]
             MOV AL,DS:[DI+BX]
             CMP AL,LEER
             JNE @UNTEN
             MOV BH,8
    @FORJ:   MOV DL,CS:[SI]
             MOV DH,DL
             ADD DH,BL
             MOV AH,DH
    @WHILE:  PUSH DI
             PUSH BX
             MOV BL,DH
             MOV BH,0
             ADD DI,BX
             MOV AL,DS:[DI]
             POP BX
             POP DI
             CMP AL,CL
             JNE @RAUS
             ADD DH,DL
             JMP @WHILE
    @RAUS:   CMP DH,AH
             JE @ENDE
             PUSH DI
             PUSH BX
             MOV BL,DH
             MOV BH,0
             ADD DI,BX
             MOV AL,DS:[DI]
             POP BX
             POP DI
             CMP AL,CH
             JNE @ENDE
             POP SI
             MOV ES:[SI],BL
             INC SI
             JMP @BREAK
    @ENDE:   INC SI
             DEC BH
             JNE @FORJ
    @UNTEN:  POP SI
    @BREAK:  POP BX
             INC BP
             DEC BH
             JNE @FORI
             JMP @FINE
    @INDEX:  DB 11,18,81,88,12,13,14,15,16,17,21,31,41,51,61,71
             DB 28,38,48,58,68,78,82,83,84,85,86,87,22,23,24,25
             DB 26,27,37,47,57,67,77,76,75,74,73,72,62,52,42,32
             DB 33,34,35,36,46,56,66,65,64,63,53,43
    @WEITE:  DB -11,-10,-9,-1,1,9,10,11
    @FINE:   MOV BX,SI
             POP SI
             POP BP
             POP DS
             SUB BX,SI
             LES DI,N
             MOV ES:[DI],BL
   END
  END;
{****************************************************************************}
{*       ENDABRECHNUNG, COMPUTER- UND MENSCHENZUG, UTILITIES                *}
{****************************************************************************}
 PROCEDURE ABRECHNUNG(ENDE:BOOLEAN);
  VAR W,S,I,J,HFARBE,SFARBE:BYTE;
      X,Y:WORD;
      ANZEIGE,ZAHL:STRING;
  BEGIN
   W:=0;S:=0;MAUSON(FALSE);
   FOR I:=1 TO GROESSE DO
    FOR J:=1 TO GROESSE DO
     CASE FELD[10*I+J] OF
      COMPUTER : INC(S);
      MENSCH   : INC(W)
     END;
   X:=BREITE*(GROESSE+4);Y:=4*BREITE+BREITE DIV 2;
   STR(W,ZAHL);GTEXT(X+BREITE+10,Y+RADIUS DIV 2,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,11));
   IF W>1 THEN GTEXT(X+BREITE+10,Y+RADIUS DIV 2,FARBE[1],HINTERGRUND,ZAHL+' Felder.')
   ELSE GTEXT(X+BREITE+10,Y+RADIUS DIV 2,FARBE[1],HINTERGRUND,ZAHL+' Feld.');
   Y:=6*BREITE;STR(S,ZAHL);
   GTEXT(X+BREITE+10,Y+RADIUS DIV 2,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,11));
   IF S>1 THEN GTEXT(X+BREITE+10,Y+RADIUS DIV 2,FARBE[2],HINTERGRUND,ZAHL+' Felder.')
   ELSE GTEXT(X+BREITE+10,Y+RADIUS DIV 2,FARBE[2],HINTERGRUND,ZAHL+' Feld.');
   IF ENDE THEN
    BEGIN
     Y:=BREITE DIV 2+7*BREITE;{ ZEILE 6 }
     IF W<S THEN
      BEGIN
       HFARBE:=LIGHTMAGENTA;SFARBE:=BLACK;
       ANZEIGE:='Schade, schade';ZAHL:='Der schlaue PC hat gewonnen!'
      END;
     IF S<W THEN
      BEGIN
       HFARBE:=LIGHTBLUE;SFARBE:=YELLOW;
       ANZEIGE:='Glckwunsch!';ZAHL:='Du hast mich besiegt!'
      END;
     IF W=S THEN
      BEGIN
       HFARBE:=LIGHTGREEN;SFARBE:=LIGHTRED;
       ANZEIGE:='REMIS';ZAHL:='Keiner ist Sieger!'
      END;
     MELDUNG(320,100,'Das Spiel ist nun zu Ende',ANZEIGE,ZAHL,HFARBE,SFARBE);
    END;
   MAUSON(TRUE);
  END;

 PROCEDURE SCHREIBZUGLISTE(AMZUG:SPIELER;N:BYTE;ZL:SPIELZUGLISTE);
  VAR I,K,S,Z:BYTE;
      X,Y:WORD;
      AUSGABE:STRING;
  BEGIN
   MAUSON(FALSE);
   IF ZEIGEN THEN
    FOR K:=1 TO N DO
     BEGIN
      Z:=ZL[K] DIV 10;S:=ZL[K] MOD 10;
      X:=BREITE DIV 2+Z*BREITE;
      Y:=(S+1)*BREITE+BREITE DIV 2;
      SETFILLSTYLE(SOLIDFILL,FARBE[3]);FLOODFILL(X,Y,HINTERGRUND)
     END;
   IF AMZUG=MENSCH THEN AUSGABE:='Deine' ELSE AUSGABE:='Meine';
   AUSGABE:=AUSGABE+' mglichen Zge : ';IF N>17 THEN K:=17 ELSE K:=N-1;
   FOR I:=1 TO K DO AUSGABE:=AUSGABE+CHAR(64+ZL[I] DIV 10)+CHAR(48+ZL[I] MOD 10)+'-';
   X:=BREITE DIV 2;Y:=BREITE*(GROESSE+3);
   BOX(X,Y,MAXX-10,Y+3+2*TEXTHEIGHT('H'),HINTERGRUND,4,TRUE);
   IF N>17 THEN
    BEGIN
     GTEXT(X,Y,SCHRIFT,HINTERGRUND,AUSGABE);AUSGABE:='';Y:=Y+3+TEXTHEIGHT('H');
     X:=X+TEXTWIDTH('Deine mglichen Zge : ');
     FOR I:=18 TO N-1 DO
      AUSGABE:=AUSGABE+CHAR(64+ZL[I] DIV 10)+CHAR(48+ZL[I] MOD 10)+'-';
    END;
   AUSGABE:=AUSGABE+CHAR(64+ZL[N] DIV 10)+CHAR(48+ZL[N] MOD 10);
   GTEXT(X,Y,SCHRIFT,HINTERGRUND,AUSGABE);MAUSON(TRUE);
  END;

 FUNCTION KEINZUG(F:SPIELFELD;AMZUG:SPIELER):BOOLEAN;
  VAR AN:BYTE; ZL:SPIELZUGLISTE;
  BEGIN
   GENZUGLISTE(F,AMZUG,AN,ZL);
   KEINZUG:=AN=0
  END;

 PROCEDURE SCHREIBZUGNUMMER(NR:INTEGER);
  VAR ZAHL:STRING;
  BEGIN
   MAUSON(FALSE);STR(NR,ZAHL);
   IF LENGTH(ZAHL)=1 THEN ZAHL:=ZAHL+' ';
   GTEXT(MAXX-95,42,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,11));
   SETTEXTJUSTIFY(RIGHTTEXT,TOPTEXT);
   SETCOLOR(SCHRIFT);OUTTEXTXY(MAXX-10,42,'Zug-Nr.: '+ZAHL);
   MAUSON(TRUE);SETTEXTJUSTIFY(LEFTTEXT,TOPTEXT);
  END;

{ FUNCTION WERT(VAR F:SPIELFELD):INTEGER;
  VAR K:BYTE;
      ECKWERT,COM,SP:INTEGER;
  BEGIN
   INC(COUNT);MOVE(BW8,BW,SIZEOF(BW8));ECKWERT:=20;
   IF F[11]<>LEER THEN
    BEGIN BW[12]:=ECKWERT;BW[21]:=ECKWERT;BW[22]:=ECKWERT END;
   IF F[18]<>LEER THEN
    BEGIN BW[17]:=ECKWERT;BW[27]:=ECKWERT;BW[28]:=ECKWERT END;
   IF F[81]<>LEER THEN
    BEGIN BW[71]:=ECKWERT;BW[72]:=ECKWERT;BW[82]:=ECKWERT END;
   IF F[88]<>LEER THEN
    BEGIN BW[77]:=ECKWERT;BW[78]:=ECKWERT;BW[87]:=ECKWERT END;
   COM:=0;SP:=0;
   FOR K:=11 TO 88 DO
    BEGIN
     IF F[K]=MENSCH THEN INC(SP,BW[K])
     ELSE IF F[K]=COMPUTER THEN INC(COM,BW[K]);
    END;
   IF COM=0 THEN INC(SP,3000);
   IF SP=0 THEN INC(COM,3000);
   WERT:=COM-SP
  END;}

 FUNCTION WERT(VAR F:SPIELFELD):INTEGER;
  BEGIN
   INC(COUNT);
   ASM
              PUSH BP
              MOV CX,100
              MOV DI,OFFSET BW8  { BW8 ---> BW }
              MOV SI,OFFSET BW
  @MOVE:      MOV AX,[DI]
              MOV [SI],AX
              ADD DI,2
              ADD SI,2
              LOOP @MOVE
              LES DI,F
              MOV SI,OFFSET BW
              MOV AX,20
              MOV DL,ES:[DI+11]   { 1. Ecke }
              CMP DL,LEER
              JE @ECKE2
              MOV [SI+24],AX
              MOV [SI+42],AX
              MOV [SI+44],AX
  @ECKE2:     MOV DL,ES:[DI+18]
              CMP DL,LEER
              JE @ECKE3
              MOV [SI+34],AX
              MOV [SI+54],AX
              MOV [SI+56],AX
  @ECKE3:     MOV DL,ES:[DI+81]
              CMP DL,LEER
              JE @ECKE4
              MOV [SI+142],AX
              MOV [SI+144],AX
              MOV [SI+164],AX
  @ECKE4:     MOV DL,ES:[DI+88]
              CMP DL,LEER
              JE @ECKENEND
              MOV [SI+154],AX
              MOV [SI+156],AX
              MOV [SI+174],AX
   @ECKENEND: MOV CX,0
              MOV AX,0
              MOV BX,88
   @FORZ:     MOV DL,ES:[DI+BX]
              CMP DL,2            { MENSCH }
              JE @MENSCH
              CMP DL,3            { COMPUTER }
              JE @COMPUTER
   @WEITER:   DEC BL
              CMP BL,10
              JNE @FORZ
              JMP @ENDE
   @COMPUTER: MOV BP,BX
              ADD BP,BX
              INC AX
              ADD AX,DS:[SI+BP]
              JMP @WEITER
   @MENSCH:   MOV BP,BX
              ADD BP,BX
              INC CX
              ADD CX,DS:[SI+BP]
              JMP @WEITER
   @ENDE:     POP BP
              CMP CX,0
              JNZ @M0
              ADD AX,3000
              JMP @RECHNE
   @M0:       CMP AX,0
              JNZ @SUB
              ADD CX,3000
              JMP @RECHNE
   @SUB:      SUB AX,CX
   @RECHNE:   MOV @RESULT,AX
              END
  END;

 FUNCTION MAX(X,Y:INTEGER):INTEGER;
  BEGIN IF X<Y THEN MAX:=Y ELSE MAX:=X END;

 FUNCTION MIN(X,Y:INTEGER):INTEGER;
  BEGIN IF X<Y THEN MIN:=X ELSE MIN:=Y END;

 PROCEDURE MACHZUG(VAR F:SPIELFELD;ZUG:SPIELZUG;AMZUG:SPIELER);
  BEGIN UMDREHEN(F,AMZUG,ZUG) END;

{ FUNCTION BRETTVOLL(VAR SF:SPIELFELD):BOOLEAN;
  VAR K,L,WO:BYTE;
  BEGIN
   BRETTVOLL:=TRUE;
   FOR K:=1 TO GROESSE DO
    FOR L:=1 TO GROESSE DO
     BEGIN
      WO:=K*10+L;
      IF SF[WO]=LEER THEN BEGIN BRETTVOLL:=FALSE;EXIT END
     END
  END;}

 FUNCTION BRETTVOLL(VAR SF:SPIELFELD):BOOLEAN;
  BEGIN
  ASM
              PUSH DS
              LDS DI,SF
              MOV @RESULT,1
              MOV BX,88
              MOV CX,10
   @FORZ:     MOV DL,[DI+BX]
              CMP DL,LEER   { LEER = 1 }
              JE @RAUS
              DEC BL
              CMP BL,CL
              JNE @FORZ
              JMP @ENDE
   @RAUS:     DEC @RESULT
   @ENDE:     POP DS
              END
  END;

 FUNCTION SPIELENDE(F:SPIELFELD):BOOLEAN;
  BEGIN
   SPIELENDE:=(KEINZUG(F,COMPUTER) AND KEINZUG(F,MENSCH)) OR BRETTVOLL(F)
  END;

 FUNCTION INNERHALB(ZUG:SPIELZUG):BOOLEAN;
  VAR Z,S:BYTE;
  BEGIN
   Z:=ZUG DIV 10;S:=ZUG MOD 10;
   INNERHALB:=(Z>2) AND (Z<7) AND (S>2) AND (S<7)
  END;

 PROCEDURE SUCHE_ZUG(VAR BESTZUG:SPIELZUG;VAR ALPHA_BETA:INTEGER;
                    DRAUSSEN:BOOLEAN;N:BYTE;F:SPIELFELD;AMZUG:SPIELER;ALPHA,BETA:INTEGER);
  VAR VIRFELD:SPIELFELD;
      ZUG:SPIELZUG;
      ZUGLISTE:SPIELZUGLISTE;
      M:INTEGER;
      X,Y:WORD;
      K,L,ANZAHL,I:BYTE;
      ZAHL:STRING;
  BEGIN
   IF KEINZUG(F,AMZUG) THEN ALPHA_BETA:=WERT(F)+KANN_NICHT[AMZUG]
   ELSE IF (N=0) OR BRETTVOLL(F) THEN ALPHA_BETA:=WERT(F)
   ELSE
    BEGIN
     IF (N=LEVEL) AND NEHMEN THEN
      BEGIN ZUGLISTE:=GLOBAL_LISTE;ANZAHL:=GLOBAL_AN END
     ELSE GENZUGLISTE(F,AMZUG,ANZAHL,ZUGLISTE);
     Y:=BREITE DIV 2+7*BREITE;X:=BREITE*(GROESSE+2);
     IF NOT DRAUSSEN THEN
      BEGIN
       K:=0;
       FOR L:=1 TO ANZAHL DO
        IF INNERHALB(ZUGLISTE[L]) THEN
         BEGIN INC(K);ZUGLISTE[K]:=ZUGLISTE[L] END;
       IF K>0 THEN ANZAHL:=K ELSE DRAUSSEN:=TRUE
      END;
     IF AMZUG=COMPUTER THEN
      BEGIN
       M:=ALPHA;I:=0;
       WHILE (I<ANZAHL) AND (M<BETA) DO
        BEGIN
         INC(I);
         VIRFELD:=F;ZUG:=ZUGLISTE[I];
         MACHZUG(VIRFELD,ZUG,COMPUTER);
         SUCHE_ZUG(BESTZUG,ALPHA_BETA,DRAUSSEN,N-1,VIRFELD,MENSCH,M,BETA);
         IF (N=LEVEL) AND ANZEIGEN THEN
          BEGIN
           STR(ALPHA_BETA,ZAHL);
           GTEXT(X,Y+30,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,29));
           GTEXT(X,Y+30,SCHRIFT,HINTERGRUND,'Wert von Zug '+CHAR(64+ZUG DIV 10)+CHAR(48+ZUG MOD 10)+'='+ZAHL);
           GTEXT(X,Y+60,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,29));STR(COUNT,ZAHL);
           IF COUNT<100000 THEN GTEXT(X,Y+60,SCHRIFT,HINTERGRUND,ZAHL+' analysierte Stellungen')
           ELSE GTEXT(X,Y+60,SCHRIFT,HINTERGRUND,ZAHL+' Stellungen')
          END;
         IF M<ALPHA_BETA THEN
          BEGIN
           M:=ALPHA_BETA;
           IF N=LEVEL THEN
            BEGIN
             BESTZUG:=ZUG;
             IF ANZEIGEN THEN
              BEGIN
               GTEXT(X,Y+45,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,29));STR(M,ZAHL);
               GTEXT(X,Y+45,LIGHTCYAN,HINTERGRUND,'bester Computerzug '+CHAR(64+ZUG DIV 10)+CHAR(48+ZUG MOD 10)+'='+ZAHL)
              END
            END
          END
        END
      END
     ELSE
      BEGIN
       M:=BETA;I:=0;
       WHILE (I<ANZAHL) AND (M>ALPHA) DO
        BEGIN
         INC(I);
         VIRFELD:=F;ZUG:=ZUGLISTE[I];
         MACHZUG(VIRFELD,ZUG,MENSCH);
         SUCHE_ZUG(BESTZUG,ALPHA_BETA,DRAUSSEN,N-1,VIRFELD,COMPUTER,ALPHA,M);
         IF M>ALPHA_BETA THEN M:=ALPHA_BETA
        END
      END;
     ALPHA_BETA:=M
    END
  END;
{****************************************************************************}
{*                        DIE SPIELBESCHREIBUNG                             *}
{****************************************************************************}
 PROCEDURE SPIELSTAND;
  VAR X,Y:WORD;
  BEGIN
   MAUSON(FALSE);X:=BREITE*(GROESSE+2);
   SETFILLSTYLE(SOLIDFILL,HINTERGRUND);BAR(X-5,55,MAXX-7,MAXY-7);
   X:=BREITE*(GROESSE+3);Y:=4*BREITE;
   PUTIMAGE(X-BREITE DIV 2,Y,TEILE[9]^,NORMALPUT);
   GTEXT(X+BREITE,Y+10,FARBE[1],HINTERGRUND,SPIELER1+' besitzt');
   Y:=6*BREITE;PUTIMAGE(X-BREITE DIV 2,Y-BREITE DIV 2,TEILE[0]^,NORMALPUT);
   GTEXT(X+BREITE,Y-RADIUS DIV 2,FARBE[2],HINTERGRUND,SPIELER2+' besitzt');
   ABRECHNUNG(FALSE);MAUSON(TRUE);
  END;

 PROCEDURE ANLEITUNG;
   VAR K:BYTE;
  BEGIN
   FOR K:=1 TO 20 DO DTEXT[K]:=ANLEITUNGSTEXT[K];
   DIALOG(320,100,LIGHTRED,BLACK,'Anleitung');
  END;
{****************************************************************************}
{*                          STEINEDREHEN                                     *}
{****************************************************************************}
 PROCEDURE STEINEDREHEN(SF:SPIELFELD;ZUG:SPIELZUG;AMZUG:SPIELER);
  PROCEDURE STEINE(VAR ZL:SPIELZUGLISTE;VAR N:BYTE;AMZUG:SPIELER;ZUG:SPIELZUG);
   VAR SCHRITT,I,WO,ALTWO:SHORTINT;
       G:SPIELER;
   BEGIN
    G:=GEGNER[AMZUG];SF[ZUG]:=AMZUG;N:=0;
    FOR I:=1 TO 8 DO
     BEGIN
      SCHRITT:=WEITE[I];WO:=ZUG+SCHRITT;ALTWO:=WO;
      WHILE SF[WO]=G DO INC(WO,SCHRITT);
      IF (SF[WO]=AMZUG) AND (WO<>ALTWO) THEN
       BEGIN
        DEC(WO,SCHRITT);
        WHILE WO<>ZUG DO BEGIN INC(N);ZL[N]:=WO;DEC(WO,SCHRITT) END
       END
     END
   END;

  VAR DREHEN:SPIELZUGLISTE;
      ND,K,I:BYTE;
      X,Y:WORD;
  BEGIN{ of STEINEDREHEN }
   STEINE(DREHEN,ND,AMZUG,ZUG);MAUSON(FALSE);
   IF AMZUG=COMPUTER THEN
    BEGIN
     FOR K:=9 DOWNTO 0 DO
      BEGIN
       FOR I:=1 TO ND DO
        BEGIN
         X:=(DREHEN[I] DIV 10)*BREITE;Y:=(DREHEN[I] MOD 10+1)*BREITE;
         PUTIMAGE(X,Y,TEILE[K]^,NORMALPUT);
        END;
       DELAY(200-ND)
      END
    END
   ELSE
    BEGIN
     FOR K:=0 TO 9 DO
      BEGIN
       FOR I:=1 TO ND DO
        BEGIN
         X:=(DREHEN[I] DIV 10)*BREITE;Y:=(DREHEN[I] MOD 10+1)*BREITE;
         PUTIMAGE(X,Y,TEILE[K]^,NORMALPUT);
        END;
       DELAY(200-ND)
      END
    END
  END;
{****************************************************************************}
{*                          ZUGBERECHNUNGEN                                  *}
{****************************************************************************}
 PROCEDURE COMPUTERZUG;
  VAR VIRFELD:SPIELFELD;
      AN,K,L,NL:BYTE;
      MINMAXWERT,ALPHA_BETA,T:INTEGER;
      X,Y,XAUS,YAUS,XN,YN:WORD;
      ZAHL,ZAHL2:STRING;
      ZUG:SPIELZUG;
      LISTE,ZL:SPIELZUGLISTE;
      WERTE:ARRAY[1..MAXNR]OF INTEGER;
      SORTIERT,AZEIGEN:BOOLEAN;
  BEGIN
   GENZUGLISTE(FELD,COMPUTER,AN,ZL);LISTE:=ZL;NL:=AN;
   X:=BREITE*(GROESSE+2);
   IF AN=0 THEN
    BEGIN
     Y:=BREITE DIV 2+4*BREITE;{ ZEILE 3 }
     MAUSON(TRUE);
     MELDUNG(X,Y,'Du hast Glck, der','Computer kann nicht ziehen!','',BLACK,WHITE);
     MAUSON(FALSE);
    END
   ELSE
    BEGIN
     ALTCURSOR:=CURSOR;CURSOR:=HOURGLASSCURSOR;
     MAUSON(FALSE);MAUSPIC(CURSOR.X,CURSOR.Y,SEG(CURSOR),OFS(CURSOR));
     MAUSON(TRUE);
     GTEXT(X+BREITE,7*BREITE,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
     SCHREIBZUGLISTE(COMPUTER,AN,ZL);
     Y:=BREITE DIV 2+7*BREITE;{ ZEILE 6 }
     MAUSGRENZE(BREITE,2*BREITE,9*BREITE,10*BREITE+5);
     GTEXT(X,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,15));XAUS:=X;YAUS:=Y;
     GTEXT(X,Y,FARBE[2],HINTERGRUND,'PC denkt nach!');
     COUNT:=0;LEVEL:=TIEFE;
     IF AN=1 THEN ZUG:=ZL[AN]
     ELSE IF ZUGNUMMER=1 THEN ZUG:=ZL[RANDOM(AN)+1]
     ELSE
      BEGIN
       IF NOT DRAUSSEN THEN
        BEGIN
         K:=0;
         FOR L:=1 TO AN DO
          IF INNERHALB(ZL[L]) THEN
           BEGIN INC(K);ZL[K]:=ZL[L] END;
         IF K>0 THEN AN:=K ELSE DRAUSSEN:=TRUE
        END;
       IF (ZUGNUMMER>32) AND (TIEFE>2) THEN LEVEL:=MIN(10,TIEFE+1);
       IF (ZUGNUMMER>44) AND (TIEFE>3) THEN LEVEL:=10;
       IF (ZUGNUMMER>44) AND (TIEFE>5) THEN LEVEL:=16;
       STR(LEVEL,ZAHL);GTEXT(X,Y+15,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
       GTEXT(X,Y+15,SCHRIFT,HINTERGRUND,'Suchtiefe : '+ZAHL);NEHMEN:=FALSE;
       IF AN=1 THEN ZUG:=ZL[AN]
       ELSE
       BEGIN
        IF LEVEL>4 THEN
         BEGIN
          AZEIGEN:=ANZEIGEN;
          IF ANZEIGEN THEN ANZEIGEN:=FALSE;
          FOR K:=1 TO AN DO
           BEGIN
            VIRFELD:=FELD;UMDREHEN(VIRFELD,COMPUTER,ZL[K]);
            SUCHE_ZUG(ZUG,MINMAXWERT,DRAUSSEN,3,VIRFELD,MENSCH,MININT,MAXINT);
            WERTE[K]:=MINMAXWERT
           END;
          REPEAT
           SORTIERT:=TRUE;
           FOR K:=1 TO AN-1 DO
            IF WERTE[K]<WERTE[K+1] THEN
             BEGIN
              T:=WERTE[K];WERTE[K]:=WERTE[K+1];WERTE[K+1]:=T;
              ZUG:=ZL[K];ZL[K]:=ZL[K+1];ZL[K+1]:=ZUG;
              SORTIERT:=FALSE
             END
          UNTIL SORTIERT;
          SCHREIBZUGLISTE(COMPUTER,AN,ZL);GLOBAL_LISTE:=ZL;
          GLOBAL_AN:=AN;NEHMEN:=TRUE;ANZEIGEN:=AZEIGEN
         END;
        SUCHE_ZUG(ZUG,ALPHA_BETA,DRAUSSEN,LEVEL,FELD,COMPUTER,MININT,MAXINT);
        NEHMEN:=FALSE
       END
      END;
     GTEXT(X+BREITE,7*BREITE,FARBE[2],HINTERGRUND,'Mein Zug : '+CHAR(64+ZUG DIV 10)+' '+CHAR(48+ZUG MOD 10));
     IF ZEIGEN THEN
      BEGIN
       MAUSON(FALSE);
       FOR K:=1 TO NL DO
        BEGIN
         X:=BREITE DIV 2+(LISTE[K] DIV 10)*BREITE;
         Y:=(LISTE[K] MOD 10+1)*BREITE+BREITE DIV 2;
         SETFILLSTYLE(SOLIDFILL,SCHRIFT);FLOODFILL(X,Y,HINTERGRUND)
        END
      END;
     MAUSON(FALSE);GTEXT(XAUS,YAUS,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,15));
     X:=(ZUG DIV 10)*BREITE;Y:=(ZUG MOD 10+1)*BREITE;
     PUTIMAGE(X,Y,TEILE[0]^,NORMALPUT);
     STEINEDREHEN(FELD,ZUG,COMPUTER);
     UMDREHEN(FELD,COMPUTER,ZUG);
     {SPIELFELDAUSGABE(FELD);}
     ABRECHNUNG(FALSE);CURSOR:=ALTCURSOR;
     MAUSPIC(0,0,SEG(CURSOR),OFS(CURSOR));
     MAUSGRENZE(0,0,MAXX,MAXY);
    END;
   MAUSON(FALSE)
  END;

 PROCEDURE SUCHZUG(VAR ZUG:SPIELZUG;SF:SPIELFELD);
  VAR VIRFELD:SPIELFELD;
      X,Y:WORD;
      AN,NR,K,L:BYTE;
      MINMAXWERT,GRENZE:INTEGER;
      ZL,LISTE:SPIELZUGLISTE;
      ZEIGEN:BOOLEAN;
  BEGIN
   GENZUGLISTE(SF,MENSCH,AN,ZL);
   IF AN=0 THEN
     BEGIN
      Y:=BREITE DIV 2+4*BREITE;{ ZEILE 3 }
      X:=BREITE*(GROESSE+2);MAUSON(TRUE);
      MELDUNG(X,Y,'Tut mir leid, aber,','Du kannst nicht ziehen!','',LIGHTRED,BLACK);
      MAUSON(FALSE);
     END
    ELSE
     BEGIN
      IF NOT DRAUSSEN THEN
       BEGIN
        K:=0;
        FOR L:=1 TO AN DO
         IF INNERHALB(ZL[L]) THEN
          BEGIN INC(K);ZL[K]:=ZL[L] END;
        IF K>0 THEN AN:=K ELSE DRAUSSEN:=TRUE
       END;
      GRENZE:=MAXINT;NR:=0;ZEIGEN:=ANZEIGEN;
      IF ANZEIGEN THEN ANZEIGEN:=FALSE;
      FOR K:=1 TO AN DO
       BEGIN
        VIRFELD:=SF;UMDREHEN(VIRFELD,MENSCH,ZL[K]);
        SUCHE_ZUG(ZUG,MINMAXWERT,DRAUSSEN,MIN(3,TIEFE),VIRFELD,COMPUTER,MININT,MAXINT);
        IF MINMAXWERT<=GRENZE THEN
         BEGIN
          IF MINMAXWERT=GRENZE THEN INC(NR);
          IF MINMAXWERT<GRENZE THEN NR:=1;
          LISTE[NR]:=ZL[K];GRENZE:=MINMAXWERT;
         END;
       END;
      K:=RANDOM(NR)+1;ZUG:=LISTE[K];ANZEIGEN:=ZEIGEN
     END
  END;

 PROCEDURE MENSCHZUG;
  VAR I,AN,S,Z:BYTE;
      IM_FELD,ERLAUBT,ENDE:BOOLEAN;
      MX,MY:INTEGER;
      ST:STRING;
      SNR,PNR:INTEGER;
      X,Y,XN,YN:WORD;
      ANZEIGE:BYTE;
      VIRFELD:SPIELFELD;
      ZUG:SPIELZUG;
      ZL:SPIELZUGLISTE;
   BEGIN
    GENZUGLISTE(FELD,MENSCH,AN,ZL);
    X:=BREITE*(GROESSE+2);
    SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
    IF AN=0 THEN
     BEGIN
      Y:=BREITE DIV 2+4*BREITE;{ ZEILE 3 }
      MELDUNG(X,Y,'Spieler kann nicht ziehen!','','',LIGHTMAGENTA,BLACK)
     END
    ELSE
     BEGIN
      SCHREIBZUGLISTE(MENSCH,AN,ZL);
      MAUSON(FALSE);Y:=BREITE DIV 2+3*BREITE;{ ZEILE 2 }
      GTEXT(X+BREITE,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
      GTEXT(X+BREITE,Y,FARBE[1],HINTERGRUND,'Dein Zug :        ');
      MAUSON(TRUE);
      REPEAT
       REPEAT
        IM_FELD:=MAUSWAHL(BREITE,2*BREITE,9*BREITE,10*BREITE+5,1);
        IF IM_FELD THEN
         BEGIN
          MAUSPOS(MX,MY);
          IM_FELD:=(GETPIXEL(MX,MY)=FARBE[3]) OR (GETPIXEL(MX,MY)=BLACK);
         END
        ELSE
        IF MAUSWAHL(0,25,MAXX DIV 2,50,1) THEN
         BEGIN
          MENUWAHL(SNR,PNR);
          IF (SNR=2) AND (PNR=1) THEN
           BEGIN
            REPEAT
             IF ZUGNUMMER>2 THEN
              BEGIN
               DEC(ZUGNUMMER,2);SCHREIBZUGNUMMER(ZUGNUMMER);
               FELD:=SPIEL[ZUGNUMMER-1];
               SPIELFELDAUSGABE(FELD);ABRECHNUNG(FALSE);
               GENZUGLISTE(FELD,MENSCH,AN,ZL);
               IF AN=0 THEN
                 MELDUNG(X,BREITE DIV 2+4*BREITE,'Spieler kann nicht ziehen!','','',LIGHTMAGENTA,BLACK)
               ELSE
                BEGIN
                 SCHREIBZUGLISTE(MENSCH,AN,ZL);MAUSON(FALSE);
                 GTEXT(X+BREITE,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
                 GTEXT(X+BREITE,Y,FARBE[1],HINTERGRUND,'Dein Zug : ');
                 SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
                END
              END
            UNTIL (AN>0) OR (ZUGNUMMER<3);
           END;
          IF SNR=2 THEN
           BEGIN
            IF PNR=4 then
             BEGIN
              CH:=Auswahl(MAXX div 2,100,'Sollen deine mglichen','Zge angezeigt werden?','',
                          'Aber sicher','Brauch ich nicht',LIGHTRED,BLACK,1);
              IF CH='A' THEN BEGIN ZEIGEN:=TRUE;ANZEIGE:=FARBE[3] END
              ELSE BEGIN ZEIGEN:=FALSE;ANZEIGE:=BLACK END;
              MAUSON(FALSE);
              FOR K:=1 TO AN DO
               BEGIN
                XN:=BREITE DIV 2+(ZL[K] MOD 10)*BREITE;
                YN:=(ZL[K] DIV 10+1)*BREITE+BREITE DIV 2;
                SETFILLSTYLE(SOLIDFILL,ANZEIGE);FLOODFILL(XN,YN,HINTERGRUND)
               END;
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE)
             END;
            IF PNR=3 then
             BEGIN
              WAHL(300,100,LIGHTGREEN,WHITE,'Auswahl der Spielstrke',TIEFE);
              STR(TIEFE,TSTR);
              MELDUNG(320,200,'Gewhlt wurde die Strke '+TSTR,
                      COPY(STAERKE[TIEFE],5,20),'',LIGHTBLUE,YELLOW);
              MAUSON(FALSE);
              GTEXT(10,42,SCHRIFT,HINTERGRUND,'Spielstrke '+TSTR+'  ');
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
             END;
            IF PNR=2 THEN
             BEGIN
              VIRFELD:=FELD;MAUSON(FALSE);
              GTEXT(X+BREITE,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
              GTEXT(X+BREITE,Y,LIGHTMAGENTA,HINTERGRUND,'Ich suche fr Dich!');
              MAUSON(TRUE);SUCHZUG(ZUG,VIRFELD);
              MELDUNG(MAXX DIV 2,100,'Mein Vorschlag : ',CHAR(64+ZUG DIV 10)+' '+CHAR(48+ZUG MOD 10),'',LIGHTBLUE,YELLOW);
              MAUSON(FALSE);GTEXT(X+BREITE,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,20));
              GTEXT(X+BREITE,Y,FARBE[1],HINTERGRUND,'Dein Zug : ');
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
             END
           END;
          IF SNR=1 THEN
           BEGIN
            IF PNR=1 THEN
             BEGIN
              MELDUNG(320,100,'Dieses SUPER-SPIEL','wurde von Fiete entwickelt.','',LIGHTMAGENTA,LIGHTGREEN);
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);
             END;
            IF PNR=2 THEN ANLEITUNG
           END;
          IF SNR=3 THEN
           BEGIN
            IF PNR=2 THEN
             BEGIN
              CH:=AUSWAHL(MAXX div 2,100,'Willst Du die Zugbewertung ?','','','Ja','Nein',LIGHTBLUE,YELLOW,2);
              IF CH='J' THEN ANZEIGEN:=TRUE ELSE ANZEIGEN:=FALSE
             END;
            IF PNR=1 THEN
             BEGIN
              MAUSON(TRUE);
              CH:=AUSWAHL(MAXX div 2,100,'Bitte einen neuen','Mauszeiger whlen.',
                  'Was darf es denn sein:','Pfeil','Hand',LIGHTBLUE,YELLOW,0);
              IF CH='P' THEN CURSOR:=STANDARDCURSOR
              ELSE CURSOR:=FINGERCURSOR;
              MAUSON(FALSE);MAUSPIC(0,0,SEG(CURSOR),OFS(CURSOR));
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE)
             END
           END
         END
        ELSE
         IF (MAUSKEY>0) AND (MAUSIN(6,6,30,20)) THEN
          BEGIN
           BOX(7,7,29,19,KNOPF,2,FALSE);
           ENDE:=AUSWAHL(500,270,'Willst Du wirklich','das Spiel beenden?','','Ja, leider','Nein',BLACK,WHITE,2)='J';
           IF ENDE THEN BEGIN MAUSON(FALSE);ABBRUCH:=TRUE;EXIT END
           ELSE
            BEGIN
             BOX(6,6,30,20,KNOPF,1,FALSE);
             SETZMAUS(MAXX DIV 4,MAXY DIV 2)
            END
          END;
       UNTIL IM_FELD;
       S:=ROUND((MX/ASFAK-BREITE DIV 2)/BREITE);
       Z:=ROUND((MY-BREITE DIV 2)/BREITE)-1;
       ZUG:=S*10+Z;ERLAUBT:=FALSE;
       FOR I:=1 TO AN DO
        IF (Z=ZL[I] MOD 10) AND (S=ZL[I] DIV 10) THEN ERLAUBT:=TRUE;
       IF NOT ERLAUBT THEN
        BEGIN
         PIEP;
         MELDUNG(320,100,'Was soll das?',CHAR(64+ZUG DIV 10)+CHAR(48+ZUG MOD 10)+' ist NICHT zulssig!','',LIGHTRED,BLACK);
         SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
        END
      UNTIL ERLAUBT;
      MAUSON(FALSE);
      BOX(X-2,BREITE DIV 2+7*BREITE-2,MAXX-7,BREITE*(GROESSE+2),HINTERGRUND,4,TRUE);
      GTEXT(X+BREITE+90,Y,FARBE[1],HINTERGRUND,CHAR(64+ZUG DIV 10)+' '+CHAR(48+ZUG MOD 10));
      IF ZEIGEN THEN
       BEGIN
        MAUSON(FALSE);
        FOR K:=1 TO AN DO
         BEGIN
          X:=BREITE DIV 2+(ZL[K] DIV 10)*BREITE;
          Y:=(ZL[K] MOD 10+1)*BREITE+BREITE DIV 2;
          SETFILLSTYLE(SOLIDFILL,SCHRIFT);FLOODFILL(X,Y,HINTERGRUND)
         END
       END;
      X:=(ZUG DIV 10)*BREITE;Y:=(ZUG MOD 10+1)*BREITE;
      MAUSON(FALSE);PUTIMAGE(X,Y,TEILE[9]^,NORMALPUT);
      STEINEDREHEN(FELD,ZUG,MENSCH);
      UMDREHEN(FELD,MENSCH,ZUG);
      {SPIELFELDAUSGABE(FELD);}
      ABRECHNUNG(FALSE);
      IF NOT INNERHALB(ZUG) THEN DRAUSSEN:=TRUE
     END;
    MAUSON(FALSE);
   END;
{****************************************************************************}
{*                        DIE SPIELPARAMETER                                *}
{****************************************************************************}
 PROCEDURE GRAFIKTEILE;
  VAR SIZE:WORD;
      I:BYTE;
  BEGIN
   CLEARDEVICE;
   SETLINESTYLE(SOLIDLN,0,THICKWIDTH);
   SIZE:=IMAGESIZE(0,0,BREITE,BREITE);
   FOR I:=0 TO 4 DO
    BEGIN
     SETFILLSTYLE(SOLIDFILL,HINTERGRUND);
     BAR(0,0,BREITE,BREITE);
     GETMEM(TEILE[I],SIZE);
     SETFILLSTYLE(SOLIDFILL,FARBE[2]);SETCOLOR(FARBE[2]);
     ELLIPSE(BREITE DIV 2,BREITE DIV 2,0,360,RADIUS,RADIUS-4*I);
     FLOODFILL(BREITE DIV 2,BREITE DIV 2,FARBE[2]);
     SETCOLOR(DARKGRAY);
     ELLIPSE(BREITE DIV 2,BREITE DIV 2,0,360,RADIUS-2,RADIUS-4*I-2);
     GETIMAGE(0,0,BREITE,BREITE,TEILE[I]^);
    END;
   FOR I:=5 TO 9 DO
    BEGIN
     SETFILLSTYLE(SOLIDFILL,HINTERGRUND);
     BAR(0,0,BREITE,BREITE);
     GETMEM(TEILE[I],SIZE);
     SETFILLSTYLE(SOLIDFILL,FARBE[1]);SETCOLOR(FARBE[1]);
     ELLIPSE(BREITE DIV 2,BREITE DIV 2,0,360,RADIUS,4*I-RADIUS);
     FLOODFILL(BREITE DIV 2,BREITE DIV 2,FARBE[1]);
     SETCOLOR(DARKGRAY);
     ELLIPSE(BREITE DIV 2,BREITE DIV 2,0,360,RADIUS-2,4*I-RADIUS-2);
     GETIMAGE(0,0,BREITE,BREITE,TEILE[I]^);
    END;
   SETLINESTYLE(SOLIDLN,0,NORMWIDTH);
  END;

 PROCEDURE MENSCHPARTIE;
  VAR ANZEIGE,I,AN,S,Z,FK:BYTE;
      IM_FELD,ERLAUBT,ENDE:BOOLEAN;
      MX,MY,XN,YN,SNR,PNR:INTEGER;
      AUSGABE:STRING;
      X,Y:WORD;
      ZUG:SPIELZUG;
      ZL:SPIELZUGLISTE;
  BEGIN
   GENZUGLISTE(FELD,DRAN,AN,ZL);
   X:=BREITE*(GROESSE+2);
   SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
   FK:=1;AUSGABE:=SPIELER1;
   IF DRAN=COMPUTER THEN BEGIN FK:=2;AUSGABE:=SPIELER2 END;
   IF AN=0 THEN
    BEGIN
     Y:=BREITE DIV 2+4*BREITE;
     MELDUNG(X,Y,AUSGABE+' kann nicht ziehen!','','',FARBE[FK],BLACK)
    END
   ELSE
    BEGIN
     SCHREIBZUGLISTE(DRAN,AN,ZL);
     MAUSON(FALSE);Y:=BREITE DIV 2+3*BREITE;
     GTEXT(X,Y,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,29));
     GTEXT(X,Y,FARBE[FK],HINTERGRUND,AUSGABE+' zieht auf :   ');
     GTEXT(X,Y+4*BREITE,HINTERGRUND,HINTERGRUND,COPY(LEERTASTE,1,29));
     GTEXT(X,Y+4*BREITE,FARBE[FK],HINTERGRUND,AUSGABE+' ist dran!');PIEP;
     MAUSON(TRUE);
     REPEAT
      REPEAT
       IM_FELD:=MAUSWAHL(BREITE,2*BREITE,9*BREITE,10*BREITE+5,1);
       IF MAUSWAHL(0,25,MAXX DIV 2,50,1) THEN
         BEGIN
          MENUWAHL(SNR,PNR);
          IF (SNR=2) AND (PNR=1) THEN
           BEGIN
            REPEAT
             IF ZUGNUMMER>2 THEN
              BEGIN
               DEC(ZUGNUMMER,2);SCHREIBZUGNUMMER(ZUGNUMMER);
               FELD:=SPIEL[ZUGNUMMER-1];
               SPIELFELDAUSGABE(FELD);ABRECHNUNG(FALSE);
               GENZUGLISTE(FELD,DRAN,AN,ZL);
               IF AN=0 THEN
                 MELDUNG(X,BREITE DIV 2+4*BREITE,'Spieler kann nicht ziehen!','','',LIGHTMAGENTA,BLACK)
               ELSE
                BEGIN
                 SCHREIBZUGLISTE(DRAN,AN,ZL);
                 SETZMAUS(MAXX DIV 4,MAXY DIV 2);
                END
              END
            UNTIL (AN>0) OR (ZUGNUMMER<3);
           END;
          IF SNR=2 THEN
           BEGIN
            IF PNR=4 then
             BEGIN
              CH:=Auswahl(MAXX div 2,100,'Sollen deine mglichen','Zge angezeigt werden?','',
                          'Aber sicher','Brauch ich nicht',LIGHTRED,BLACK,1);
              IF CH='A' THEN BEGIN ZEIGEN:=TRUE;ANZEIGE:=FARBE[3] END
              ELSE BEGIN ZEIGEN:=FALSE;ANZEIGE:=BLACK END;
              MAUSON(FALSE);
              FOR K:=1 TO AN DO
               BEGIN
                XN:=BREITE DIV 2+(ZL[K] DIV 10)*BREITE;
                YN:=(ZL[K] MOD 10+1)*BREITE+BREITE DIV 2;
                SETFILLSTYLE(SOLIDFILL,ANZEIGE);FLOODFILL(XN,YN,HINTERGRUND)
               END;
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE)
             END;
           END;
          IF SNR=1 THEN
           BEGIN
            IF PNR=1 THEN
             BEGIN
              MELDUNG(320,100,'Dieses SUPER-SPIEL','wurde von Fiete entwickelt.','',LIGHTMAGENTA,LIGHTGREEN);
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);
             END;
            IF PNR=2 THEN ANLEITUNG
           END;
          IF SNR=3 THEN
           BEGIN
            IF PNR=1 THEN
             BEGIN
              MAUSON(TRUE);
              CH:=AUSWAHL(MAXX div 2,100,'Bitte einen neuen','Mauszeiger whlen.',
                  'Was darf es denn sein:','Pfeil','Hand',LIGHTBLUE,YELLOW,0);
              IF CH='P' THEN CURSOR:=STANDARDCURSOR
              ELSE CURSOR:=FINGERCURSOR;
              MAUSON(FALSE);MAUSPIC(0,0,SEG(CURSOR),OFS(CURSOR));
              SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE)
             END
           END
         END;
       IF IM_FELD THEN
        BEGIN
         MAUSPOS(MX,MY);
         IM_FELD:=(GETPIXEL(MX,MY)=FARBE[3]) OR (GETPIXEL(MX,MY)=BLACK);
        END
       ELSE
        IF (MAUSKEY>0) AND (MAUSIN(6,6,30,20)) THEN
         BEGIN
          BOX(7,7,29,19,KNOPF,2,FALSE);
          ENDE:=AUSWAHL(500,270,'Willst Du wirklich','das Spiel beenden?','','Ja, leider','Nein',BLACK,WHITE,2)='J';
          IF ENDE THEN BEGIN MAUSON(FALSE);ABBRUCH:=TRUE;EXIT END
          ELSE
           BEGIN
            BOX(6,6,30,20,KNOPF,1,FALSE);
            SETZMAUS(MAXX DIV 4,MAXY DIV 2)
           END
         END;
      UNTIL IM_FELD;
      S:=ROUND((MX/ASFAK-BREITE DIV 2)/BREITE);
      Z:=ROUND((MY-BREITE DIV 2)/BREITE)-1;
      ZUG:=S*10+Z;ERLAUBT:=FALSE;
      FOR I:=1 TO AN DO
       IF (Z=ZL[I] MOD 10) AND (S=ZL[I] DIV 10) THEN ERLAUBT:=TRUE;
      IF NOT ERLAUBT THEN
       BEGIN
        PIEP;
        MELDUNG(320,100,'Was soll das?',CHAR(64+ZUG DIV 10)+CHAR(48+ZUG MOD 10)+' ist NICHT zulssig!','',LIGHTRED,BLACK);
        SETZMAUS(MAXX DIV 4,MAXY DIV 2);MAUSON(TRUE);
       END
     UNTIL ERLAUBT;
     MAUSON(FALSE);
     BOX(X-2,BREITE DIV 2+7*BREITE-2,MAXX-7,BREITE*(GROESSE+2),HINTERGRUND,4,TRUE);
     GTEXT(X+4*BREITE+20,Y,FARBE[FK],HINTERGRUND,CHAR(64+ZUG DIV 10)+' '+CHAR(48+ZUG MOD 10));
     IF ZEIGEN THEN
      BEGIN
       MAUSON(FALSE);
       FOR K:=1 TO AN DO
        BEGIN
         X:=BREITE DIV 2+(ZL[K] DIV 10)*BREITE;
         Y:=(ZL[K] MOD 10+1)*BREITE+BREITE DIV 2;
         SETFILLSTYLE(SOLIDFILL,SCHRIFT);FLOODFILL(X,Y,HINTERGRUND)
        END
      END;
     X:=(ZUG DIV 10)*BREITE;Y:=(ZUG MOD 10+1)*BREITE;
     MAUSON(FALSE);
     IF DRAN=MENSCH THEN K:=9 ELSE K:=0;
     PUTIMAGE(X,Y,TEILE[K]^,NORMALPUT);
     STEINEDREHEN(FELD,ZUG,DRAN);
     UMDREHEN(FELD,DRAN,ZUG);
     ABRECHNUNG(FALSE);
    END
  END;

 PROCEDURE INIT;
  VAR C:CHAR;
      Z,S:BYTE;
  BEGIN
   MAUSON(FALSE);TIEFE:=0;ABBRUCH:=FALSE;
   FOR Z:=0 TO 99 DO FELD[Z]:=RAND;
   FOR Z:=1 TO GROESSE DO
    FOR S:=1 TO GROESSE DO FELD[10*Z+S]:=LEER;
   FELD[44]:=COMPUTER;FELD[55]:=COMPUTER;
   FELD[45]:=MENSCH;FELD[54]:=MENSCH;
   SPIELER1:='Mensch';SPIELER2:='Computer';
   CLEARDEVICE;OPEN_WINDOW(0,0,MAXX,MAXY,HINTERGRUND,WHITE,KNOPF,'Reversi');
   FELDAUSGABE;SPIELFELDAUSGABE(FELD);ZWEISPIELERMODUS:=FALSE;
   C:=AUSWAHL(500,MAXY DIV 2,'Mensch gegen Computer','','','Ja','Nein',BLUE,WHITE,1);
   IF C='N' THEN
    BEGIN
     SPIELER1:='Spieler 1';SPIELER2:='Spieler 2';
     ZWEISPIELERMODUS:=TRUE;SPIELSTAND;
     DRAN:=MENSCH;ZEIGEN:=TRUE;EXIT
    END;
   SPIELSTAND;
   WAHL(300,100,LIGHTGREEN,WHITE,'Auswahl der Spielstrke',TIEFE);
   STR(TIEFE,TSTR);
   MELDUNG(320,200,'Gewhlt wurde die Strke '+TSTR,COPY(STAERKE[TIEFE],5,20),'',LIGHTBLUE,YELLOW);
   C:=AUSWAHL(500,270,'Willst du beginnen','','','Ja','Nein',YELLOW,RED,0);
   IF C='J' THEN DRAN:=MENSCH ELSE DRAN:=COMPUTER;
   C:=AUSWAHL(500,270,'soll ich alle','mgliche Felder fr','dich markieren','Ja','Nein',LIGHTGRAY,LIGHTBLUE,1);
   IF C='J' THEN ZEIGEN:=TRUE ELSE ZEIGEN:=FALSE;
   ANZEIGEN:=FALSE;
   IF TIEFE>3 THEN DRAUSSEN:=FALSE ELSE DRAUSSEN:=TRUE;
   IF DRAN=COMPUTER THEN
    BEGIN
     FELD[44]:=MENSCH;FELD[55]:=MENSCH;
     FELD[45]:=COMPUTER;FELD[54]:=COMPUTER;
    END;
   SPIELFELDAUSGABE(FELD)
  END;
{****************************************************************************}
{*                           DAS HAUPTPROGRAMM                              *}
{****************************************************************************}
 BEGIN
  CLRSCR;RANDOMIZE;
  IF NOT MAUSINIT THEN
   BEGIN
    WRITELN('Kann deine Maus NICHT finden!');
    CH:=READKEY;HALT
   END;
  INSTALL_GRAPH;BREITE:=(MAXY+1) DIV TEIL;
  FARBE[1]:=LIGHTRED;FARBE[2]:=LIGHTGREEN;FARBE[3]:=LIGHTBLUE;
  RADIUS:=(MAXY-MAXY DIV TEIL) DIV (2*TEIL);
  CURSOR:=FINGERCURSOR;MAUSPIC(CURSOR.X,CURSOR.Y,SEG(CURSOR),OFS(CURSOR));
  HINTERGRUND:=LIGHTGRAY;SCHRIFT:=BLACK;GRAFIKTEILE;
  MAUSGRENZE(0,0,MAXX,MAXY);
  MENUINIT(6,21,MAXX-6,BLUE,YELLOW,MENUTEXT,SEITENZAHL,PUNKTZAHL,MAXLEN);
  REPEAT
   INIT;ABRECHNUNG(FALSE);MAUSON(FALSE);
   ZUGNUMMER:=0;SPIEL[ZUGNUMMER]:=FELD;
   BOX(6,37,MAXX-6,52,HINTERGRUND,1,FALSE);STR(TIEFE,TSTR);
   IF NOT ZWEISPIELERMODUS THEN
     GTEXT(10,42,SCHRIFT,HINTERGRUND,'Spielstrke '+TSTR);
   SHOWMENU;
   REPEAT
    INC(ZUGNUMMER);SCHREIBZUGNUMMER(ZUGNUMMER);
    IF ZWEISPIELERMODUS THEN MENSCHPARTIE
    ELSE IF DRAN=MENSCH THEN MENSCHZUG ELSE COMPUTERZUG;
    SPIEL[ZUGNUMMER]:=FELD;DRAN:=GEGNER[DRAN]
   UNTIL SPIELENDE(FELD) OR ABBRUCH;
   IF NOT ABBRUCH THEN ABRECHNUNG(TRUE);MAUSON(TRUE);
   IF ZUGNUMMER>1 THEN
    BEGIN
     CH:=AUSWAHL(500,270,'Soll ich den ganzen','Spielverlauf zeigen','','Ja','Nein',YELLOW,BLUE,2);
     IF CH='J' THEN
      BEGIN
       FOR K:=1 TO ZUGNUMMER DO
        BEGIN
         SCHREIBZUGNUMMER(K);
         FELD:=SPIEL[K];SPIELFELDAUSGABE(FELD);
         IF K<ZUGNUMMER THEN
          BEGIN
           CH:=AUSWAHL(500,270,'Weiter','','','Ja','Nein',RED,WHITE,1);
           IF CH='N' THEN BREAK
          END
        END
      END;
     IF K=ZUGNUMMER THEN SPIELENDE(FELD)
    END;
   CH:=AUSWAHL(500,270,'Willst Du noch','eine Runde spielen ?','','Ja','Nein',LIGHTCYAN,BLACK,1);
   MAUSON(FALSE);
  UNTIL CH='N';
  MENUFREE
 END.
